<?php
/**
 * Flatnux default head
 * 
 * @package Flatnux
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 * 
 */
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}
global $_FN;
$lang = $_FN['lang'];
$theme = $_FN['theme'];
//forzo il charset
header("Content-Type: text/html; charset=" . _CHARSET,true);


/* include custom head if exists */
if ( file_exists("themes/$theme/head.php") )
	include ("themes/$theme/head.php");
else
{
	// start HTML headers
	$doctype = theme_doctype();
	$xmlns = "";
	if ( preg_match("/DTD HTML/",$doctype) )
	{
		$_FN['close_tag'] = "";
	}
	elseif ( preg_match("/DTD XHTML/",$doctype) )
	{
		$_FN['close_tag'] = " /";
		$xmlns = "xmlns=\"http://www.w3.org/1999/xhtml\"";
	}
	$close_tag = $_FN['close_tag'];
	echo $doctype;
	echo "<html $xmlns lang=\"$lang\">\n";
	echo "<head>\n";
	$sitename = $_FN['sitetitle'] ;
	if ( $_FN['vmod'] != "" )
	{
		$tmp = preg_replace("/^[0-9][0-9]_/s","",$_FN['vmod']);
		$title = str_replace("_","&nbsp;",str_replace(".php","",$tmp));
		$titlesun = getLang("sections/{$_FN['vmod']}/lang.xml",$title);
		$_FN['sitetitle'] = "$sitename &raquo;  $titlesun";
	}
	if ( file_exists("sections/" . $_FN['vmod'] . "/sethead.php") )
		include ("sections/" . $_FN['vmod'] . "/sethead.php");
	echo "\t<title>{$_FN['sitetitle']}</title>\n";
	echo "\t<meta http-equiv=\"Content-Type\" content=\"text/html; charset=" . _CHARSET . "\" $close_tag>\n";
	echo "\t<meta name=\"Content-Language\" content=\"{$_FN['lang']}\" $close_tag>\n";
	echo "\t<meta name=\"RESOURCE-TYPE\" content=\"DOCUMENT\" $close_tag>\n";
	echo "\t<meta http-equiv=\"EXPIRES\" content=\"0\" $close_tag>\n";
	echo "\t<meta name=\"DISTRIBUTION\" content=\"GLOBAL\" $close_tag>\n";
	echo "\t<meta name=\"AUTHOR\" content=\"{$_FN['sitename']}\" $close_tag>\n";
	echo "\t<meta name=\"COPYRIGHT\" content=\"Copyright (c) 2005 by {$_FN['sitename']}\" $close_tag>\n";
	if ( $_FN['keywords'] != "" )
		echo "\t<meta name=\"KEYWORDS\" content=\"{$_FN['keywords']}\" $close_tag>\n";
	echo "\t<meta name=\"DESCRIPTION\" content=\"{$_FN['sitename']}\" $close_tag>\n";
	echo "\t<meta name=\"ROBOTS\" content=\"INDEX, FOLLOW\" $close_tag>\n";
	echo "\t<meta name=\"REVISIT-AFTER\" content=\"1 DAYS\" $close_tag>\n";
	echo "\t<meta name=\"RATING\" content=\"GENERAL\" $close_tag>\n";
	if ( file_exists("" . $_FN['datadir'] . "/{$_FN['lang']}/backend.xml") )
		echo "\t<link rel=\"alternate\" type=\"application/rss+xml\" title=\"{$_FN['sitename']}\" href=\"{$_FN['siteurl']}" . "" . $_FN['datadir'] . "/{$_FN['lang']}/backend.xml\" $close_tag>\n";
	if ( file_exists("themes/{$_FN['theme']}/header.php") ) //aggiunte personalizzate per l'header
		include ("themes/{$_FN['theme']}/header.php");
	IncludeCss($close_tag);
	?>
<script type="text/javascript">
	//<!--
	function check(url)
	{
		if(confirm ("<?php
	echo _SICURO?>"))
			window.location=url;
	}
	// -->
</script>
<?php
	IncludeJavascripts();
	echo "\n</head>\n";
}
/* foglio di stile (se esiste)*/
?>