<?php
/**
--------------------------------------------------------------------
FLATCALENDAR - Calendar block for Flatnux (http://www.flatnux.org)
--------------------------------------------------------------------

Author:		Marco Segato
Website:	http://marcosegato.altervista.org/
email:		segatom (at) users.sourceforge.net

Author:		Giovanni Piller Cottrer
Website:	http://gigasoft.altervista.org
email:		giovanni.piller (at) gmail.com

Author:		Alessandro Vernassa
Website:	http://speleoalex.altervista.org
email:		speleoalex (at) gmail.com

Version:	0.11splx - 20071128

License:	GNU General Public License 2

 */
global $_FN,$_FNMESSAGE;
global $mesi,$giorni;
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	$old = false;
	while ( !file_exists("include/flatnux.php"))
	{
		$d = dir(realpath("."));
		if (  !chdir("..") || $old == $d->path )
			die("flatnux not found");
		$old = $d->path;
	}
	include "include/flatnux.php";
}
require_once("sections/".  sectionlocation("news")."/functions.php");
/* ============== START SCRIPT CONFIGURATION ============== */
$sctnewsarchive = find_section("newsarchive");
$baseurl = "sections/" . $sctnewsarchive . "/block_calendar.php";
/* =============== END SCRIPT CONFIGURATION =============== */
// arrays from Flatnuke containing months and week days
// server time-shift taken from Flatnuke settings
// security conversions; if no date is given, it takes current time as default
$from = getparam("HTTP_REFERER",PAR_SERVER,SAN_NULL);
$aa = getparam("aa",PAR_GET,SAN_FLAT);
$mm = getparam("mm",PAR_GET,SAN_FLAT);
if ( $aa == "" or  !is_numeric($aa) or $aa < (date("Y") - 1000) or $aa > (date("Y") + 1000) )
{
	$aa = date("Y");
}
if ( $mm == "" or  !is_numeric($mm) or $mm < 1 or $mm > 12 )
{
	$mm = date("n");
}

$tablename = "news";
$tableNews = new FieldForm("fndatabase", $tablename, $_FN['datadir'], $_FN['lang'], $_FN['languages']);
$arraynews = $tableNews->xmltable->getRecords(array("status" => 1), false, false, "date", true);

#print_r($arraynews); //-> TEST
//---> START BUILDING CALENDAR
echo "\n<div id='calendarcontents' class='calendar'>\n";
$anno = $aa;
$mese = $mm;
$canno = date("Y",time() + (3600 * $_FN['jet_lag']));
$cmese = date("m",time() + (3600 * $_FN['jet_lag']));
// print current date and time
echo "\n<div style='padding-bottom:0.5em;text-align:left' >\n";
echo "<b>" . _DATA . ":</b> <a href=\"javascript:completeAHAH.ahah('$baseurl?aa=$canno&amp;mm=$cmese','calendar','0','GET');\">" . date($_FNMESSAGE['dateformat'],time() + (3600 * $_FN['jet_lag'])) . "</a><br />";
echo "<b>" . _ORA . ":</b> " . date("H:i",time() + (3600 * $_FN['jet_lag']));
echo "\n</div>";
echo "<table class=\"calendartable\"><thead>";
// print header navigation; something like:  Month Year 
if ( $mese == 1 )
{ // first month of the year
	$back = "aa=" . ($anno - 1) . "&amp;mm=12";
	$backtitle = $mesi[11] . " " . ($aa - 1);
}
else
{
	$back = "aa=" . $anno . "&amp;mm=" . ($mese - 1);
	$backtitle = $mesi[$mm - 2] . " " . $aa;
}
if ( $mese == 12 )
{ // last month of the year
	$next = "aa=" . ($anno + 1) . "&amp;mm=1";
	$nexttitle = $mesi[0] . " " . ($aa + 1);
}
else
{
	$next = "aa=" . $anno . "&amp;mm=" . ($mese + 1);
	$nexttitle = $mesi[intval($mm)] . " " . ($aa);
}
echo "\n<tr><td colspan=\"7\"><div style=\"text-align:center\">\n";
if ( check_ahah() )
{
	echo "<a href=\"javascript:completeAHAH.ahah('$baseurl?$back','calendar','0','GET');\" title=\"$backtitle\">&laquo;</a>&nbsp;";
}
else
	echo "<a href='index.php?$back' title='$backtitle'>&laquo;</a>&nbsp;";
echo "<b>" . $mesi[$mm - 1] . "&nbsp;$aa</b>&nbsp;";
if ( check_ahah() )
{
	echo "<a href=\"javascript:completeAHAH.ahah('$baseurl?$next','calendar','0','GET');\" title=\"$nexttitle\">&raquo;</a>";
}
else
	echo "<a href='index.php?$next' title='$nexttitle'>&raquo;</a>";
echo "\n</div></td></tr>";
// print list of days-of-week's names
echo "\n<tr class='row'>";
for ( $i = 1;$i < 7;$i++  )
{
	echo "\n\t<th abbr=\"" . $giorni[$i] . "\" scope=\"col\" title=\"" . $giorni[$i] . "\" class=\"heading\">" . substr($giorni[$i],0,2) . "</th>"; // from monday to saturday
}
echo "\n\t<th abbr=\"" . $giorni[0] . "\" scope=\"col\" title=\"" . $giorni[0] . "\" class=\"heading\">" . substr($giorni[0],0,2) . "</th>"; // from monday to saturday
echo "\n</tr></thead><tbody>";
// print empty days
$primo = mktime(0,0,0,$mm,1,$aa); // first day of the month
$delta = date("w",$primo) - 1;
#echo $delta; //-> TEST
if ( $delta ==  -1 )
{ // sunday as first day of the month
	$delta = 6;
}
if ( $delta != 0 )
{ // start a new week
	echo "\n<tr class='row'>";
}
for ( $i = 0;$i < $delta;$i++  )
{
	echo "\n<td class='blankDay'>&nbsp;</td>";
}
//dprint_r("aa=$aa mm=$mm canno=$canno cmese=$cmese lang={$_FN['lang']} date(d)=".intval(date("d")));
// print all valid days
for ( $i = 1;$i <= date("t",$primo);$i++  )
{
	if ( ($i + $delta) % 7 == 1 )
	{ // first day of the week
		echo "\n<tr class='row'>";
	}
	$thereisanews = is_there_a_news($i,$mm,$aa,$arraynews); // check if there's a news in this day
	if ( ($i == intval(date("d"))) && ($mm == date("n")) && ($aa == date("Y")) )
	{
		if ( $thereisanews != "" )
		{
			echo "\n<td class='currDay' ><a href=\"index.php?mod=$sctnewsarchive" . $thereisanews . "</a></td>";
		}
		else
			echo "\n<td class='currDay' title='today'>$i</td>"; // today
	}
	else
	{
		if ( $thereisanews != "" )
		{
			echo "\n<td class='day'><a href=\"index.php?mod=$sctnewsarchive" . $thereisanews . "</a></td>";
		}
		else
			echo "\n<td class='day'>$i</td>";
	}
	// particular cases: 1 is first day of week OR 28/29/30/31 is the last day of week
	if ( ($i + $delta) % 7 == 0 )
	{
		echo "\n</tr>\n";
	}
	else 
		if ( $i == date("t",$primo) )
		{
			for ( $h = $i;($h + $delta) % 7 != 0;$h++  )
				echo "<td class='blankDay'>&nbsp;</td>";
			echo "\n</tr>\n";
		}
}
echo "\n</tbody></table>\n";
// print options boxes to change month/year
echo "\n<form method='get' action='" . str_replace("&","&amp;",$from) . "' id='calendar_module'>";
echo "\n<div style=\"text-align:center\">";
if ( check_ahah() )
{
	echo "\n<select name='mm' onchange=\"javascript:completeAHAH.ahah('$baseurl?aa='+aa.options[aa.selectedIndex].value+'&amp;mm='+this.options[this.selectedIndex].value,'calendar','0','GET');\">";
}
else
	echo "\n<select name='mm' onchange=\"document.getElementById('calendar_module').submit()\">";
for ( $i = 1;$i <= 12;$i++  )
{
	if ( $i == $mm )
	{
		echo "\n\t<option value='$i' selected='selected'>" . $mesi[$i - 1] . "</option>";
	}
	else
		echo "\n\t<option value='$i'>" . $mesi[$i - 1] . "</option>";
}
echo "\n</select>";
if ( check_ahah() )
{
	echo "\n<select name='aa' onchange=\"javascript:completeAHAH.ahah('$baseurl?aa='+this.options[this.selectedIndex].value+'&amp;mm='+mm.options[mm.selectedIndex].value,'calendar','0','GET');\">";
}
else
	echo "\n<select name='aa' onchange=\"document.getElementById('calendar_module').submit()\">";
for ( $i = date("Y") - 10;$i <= date("Y") + 5;$i++  )
{
	if ( $i == $aa )
	{
		echo "\n\t<option value='$i' selected='selected'>" . $i . "</option>";
	}
	else
		echo "\n\t<option value='$i'>" . $i . "</option>";
}
echo "\n</select>";
//echo "\n<noscript><br /><br /><input type='submit' value='Ok' /></noscript>";
echo "\n</div>\n";
echo "\n</form>";
// END BUILDING CALENDAR <----
echo "\n</div>\n";
/**
 * Check if there's a news in a particular day
 *
 * The function verifies if it can find a news from the
 * array $arraynews that is dated $dd/$mm/$yy.
 *
 * @param int $dd Day to check
 * @param int $mm Month to check
 * @param int $yy Year to check
 * @param array $arraynews Contains the list of news for a particular month
 *
 * @return string The string that will be printed (empty or the argument of the link)
 */
function is_there_a_news($dd, $mm, $yy, $arraynews = array ())
{
	$dd = getparam($dd,PAR_NULL,SAN_FLAT);
	$mm = getparam($mm,PAR_NULL,SAN_FLAT);
	$yy = getparam($yy,PAR_NULL,SAN_FLAT);
	global $_FN;
	for ( $i = 0;$i < count($arraynews);$i++  )
	{
		$tmp = strtotime($arraynews[$i]['date']);


		$giorno = date("j",$tmp + (3600 * $_FN['jet_lag']));
		$mese = date("n",$tmp + (3600 * $_FN['jet_lag']));
		$anno = date("Y",$tmp + (3600 * $_FN['jet_lag']));


		#echo "$dd-$mm-$yy|$giorno/$mese/$anno<br />";	//-> TEST
		if ( $mese == $mm and $anno == $yy and $giorno == $dd )
		{
			$title = htmlentities($arraynews[$i]['title'],ENT_QUOTES);
			return "&amp;aa=$anno&amp;mm=$mese&amp;dd=$giorno\"  title=\"News " . $giorno . "/" . $mese . "/" . $anno . " $title\"><b>" . $dd . "</b>";
		}
	}
	return "";
}
/**
 * Verifies if the AHAH library exists.
 *
 * @return boolean TRUE or FALSE
 */
function check_ahah()
{
	if ( file_exists("include/javascripts/ahah.js") )
	{
		return TRUE;
	}
	else
		return FALSE;
}
?>