#!/bin/bash
######################### rimozione minimal ####################################
rm -rf ../flatnux-minimal/
rm -rf ./misc/* ./config.php
######################### rimozione sitemap ####################################
rm ./*sitemap*.xml
rm ./index-*.html
rm ./trovaprezzi.txt

######################### rimozione altri files  ###############################
rm ./.directory
rm ./.htaccess
find . -iname \*~ | xargs rm -f
find . -iname \.directory | xargs rm -f
find . -iname \*.menu | xargs rm -f
find . -iname \*.menu.xml | xargs rm -f
rm ./sections/90_doc
rm ./sections/78_CMR

######################### rimozione fncommerce   ###############################
rm ./sections/20_fncommerce
rm ./sections/none_Control_Center/none_modules/05_fnEcommerce
rm ./sections/30_catalog
rm ./fncommerce
######################### creazione firstinstall   #############################
touch ./misc/firstinstall
###########################    fix dei permessi   ##############################
for i in $(find . -type f); do 
	if echo "$i" | egrep -qe "\.(php|sh)$"; then 
		chmod a+x $i
	else
		chmod a-x $i 
	fi; 
done
######################### scrittura versione ###################################
pwd=$(basename $PWD) 
oldpwd=$PWD
echo $pwd-$(date +"%Y-%m.%d") > VERSION
########################    creazione zip   ####################################
cd ..
if [ -d "$pwd" ]; then
	name=$pwd-$(date +"%Y-%m.%d").tar.gz
	nameminimal=$pwd-minimal-$(date +"%Y-%m.%d").tar.gz
	namezip=$pwd-$(date +"%Y-%m.%d").zip
	namezipminimal=$pwd-minimal-$(date +"%Y-%m.%d").zip
	declare n=0
	while [ -e $namezip ]; do
		let n++
		name=$pwd-$(date +"%Y-%m.%d").$n.tar.gz
		namezip=$pwd-$(date +"%Y-%m.%d").$n.zip
		nameminimal=$pwd-minimal-$(date +"%Y-%m.%d").$n.tar.gz
		namezipminimal=$pwd-minimal-$(date +"%Y-%m.%d").$n.zip
	done

	zip -r $namezip"-devel.zip" $pwd

	mkdir ./fnbuild
	mv ./flatnux/nbproject ./fnbuild/
	mv ./flatnux/.project ./fnbuild/
	mv ./flatnux/.settings ./fnbuild/
	echo "PULIZIA COMPLETATA";

	zip -r $namezip $pwd -x flatnux/nbproject flatnux/.director\* flatnux/.project\* flatnux/.buildpath\* flatnux/\*.sh flatnux/\.settings

	mv ./fnbuild/nbproject ./flatnux/
	mv ./fnbuild/.project ./flatnux/
	mv ./fnbuild/.settings ./flatnux/
fi

######################reazione fn minimal     ##################################
cd $oldpwd
mkdir ../flatnux-minimal
mkdir ../flatnux-minimal/sections
mkdir ../flatnux-minimal/themes
mkdir ../flatnux-minimal/blocks
mkdir ../flatnux-minimal/blocks/dx
mkdir ../flatnux-minimal/blocks/sx
mkdir ../flatnux-minimal/include
mkdir ../flatnux-minimal/include/extra
mkdir ../flatnux-minimal/include/autoexec.d


cp -r ./filemanager.php ../flatnux-minimal/
cp -r ./controlcenter.php ../flatnux-minimal/
cp -r ./footer.php ../flatnux-minimal/
cp -r ./shared.php ../flatnux-minimal/
cp -r ./verify.php ../flatnux-minimal/
cp -r ./print.php ../flatnux-minimal/
cp -r ./install.php ../flatnux-minimal/
cp -r ./index.php ../flatnux-minimal/
cp -r ./head.php ../flatnux-minimal/
cp -r ./Changelog ../flatnux-minimal/
cp -r ./INSTALL ../flatnux-minimal/
cp -r ./COPYING ../flatnux-minimal/
cp -r ./AUTHOR ../flatnux-minimal/
cp -r ./VERSION ../flatnux-minimal/



mkdir ../flatnux-minimal/languages
cp  ./languages/* ../flatnux-minimal/languages/
mkdir ../flatnux-minimal/languages/sections/
cp -r  ./languages/sections/controlcenter ../flatnux-minimal/languages/sections/
mkdir ../flatnux-minimal/languages/blocks/

cp -r ./images ../flatnux-minimal/
mkdir ../flatnux-minimal/include/install
mkdir ../flatnux-minimal/include/install/fndatabase
mkdir ../flatnux-minimal/include/install/fndatabase/avatars
cp  ./include/install/fndatabase/avatars.php ../flatnux-minimal/include/install/fndatabase/avatars.php
cp -r ./themes/base ../flatnux-minimal/themes/

cp -r ./sections/10_Login ../flatnux-minimal/sections/10_Login
cp -r ./sections/none_Control_Center ../flatnux-minimal/sections/
cp -r ./sections/none_filemanager ../flatnux-minimal/sections/
cp -r ./include/xmldb* ../flatnux-minimal/include/
cp -r ./include/functions*.php ../flatnux-minimal/include/
cp -r ./include/functions.php ../flatnux-minimal/include/
cp -r ./include/shared.php ../flatnux-minimal/include/

cp -r ./include/flatnux.php ../flatnux-minimal/include/
cp -r ./include/head.php ../flatnux-minimal/include/
cp -r ./include/footer.php ../flatnux-minimal/include/
cp -r ./include/theme.php ../flatnux-minimal/include/
cp -r ./include/dynamic.php ../flatnux-minimal/include/
cp -r ./include/admin.php ../flatnux-minimal/include/
cp -r ./include/config.install.minimal.php ../flatnux-minimal/include/config.install.php
cp -r ./include/php_filters ../flatnux-minimal/include/
cp -r ./include/javascripts ../flatnux-minimal/include/
cp -r ./include/extra/rtef ../flatnux-minimal/include/extra/
cp -r ./include/extra/textarea ../flatnux-minimal/include/extra/
cp -r ./include/codepress ../flatnux-minimal/include/
cp -r ./include/auth ../flatnux-minimal/include/

cp -r ./include/autoexec.d/30_accesskey.php ../flatnux-minimal/include/autoexec.d/
cp -r ./include/autoexec.d/05_mainteance.php ../flatnux-minimal/include/autoexec.d/
cp -r ./include/autoexec.d/00_autobuild.php ../flatnux-minimal/include/autoexec.d/
cp -r ./blocks/dx/Lingua.php.xml ../flatnux-minimal/blocks/dx/
cp -r ./blocks/dx/00_Lingua.php ../flatnux-minimal/blocks/dx/

mkdir ../flatnux-minimal/include/css/



#cp -r ./gen_pack.sh ../flatnux-minimal/
cp -r ./index.php ../flatnux-minimal/

mkdir ../flatnux-minimal/misc/
touch ../flatnux-minimal/misc/firstinstall
mkdir ../flatnux-minimal/sections/10_HOME
touch ../flatnux-minimal/sections/10_HOME/home.section
echo metti qui il testo della pagina > ../flatnux-minimal/sections/10_HOME/section.it.html
rm -rf ../flatnux-minimal/images/news

cd ..

#tar cvzf  ./$nameminimal  ./flatnux-minimal
zip -r ./$namezipminimal ./flatnux-minimal


#ln -s /home/speleoalex/public_html/flatnux_doc/ /home/speleoalex/public_html/flatnux/sections/90_doc
#ln -s /home/speleoalex/public_html/flatnux_cmr/sections/78_CMR/ /home/speleoalex/public_html/flatnux/sections/78_CMR


#########################ripristino i permessi##################################
chown -R speleoalex ./flatnux*

###############################     fine    ####################################
echo creato: $namezipminimal
echo creato: $namezip


