#!/bin/bash
pwd=$(basename $PWD) 
oldpwd=$PWD
cd ..


#News ----------------
namepack=$pwd"-sections-news-"$(date +"%Y-%m.%d")
zip -r $namepack.zip \
$pwd"/sections/00_News" \
-x \*.sh \*.directory \*.project \*.settings \*.buildpath 


#statistiche ----------------
namepack=$pwd"-sections-statistics-"$(date +"%Y-%m.%d")
zip -r $namepack.zip \
$pwd"/sections/none_Statistics" $pwd"/include/autoexec.d/20_statsxml.php" \
-x \*.sh \*.directory \*.project \*.settings \*.buildpath 


#Foto ----------------
namepack=$pwd"-sections-gallery-"$(date +"%Y-%m.%d")
zip -r $namepack.zip \
$pwd"/sections/05_Gallery" \
-x \*.sh \*.directory \*.project \*.settings \*.buildpath 

#Files ----------------
namepack=$pwd"-sections-fnfiles-"$(date +"%Y-%m.%d")
zip -r $namepack.zip \
$pwd"/sections/08_Files" \
-x \*.sh \*.directory \*.project \*.settings \*.buildpath 

#Forum ----------------
namepack=$pwd"-sections-flatforum-"$(date +"%Y-%m.%d")
zip -r $namepack.zip \
$pwd"/sections/02_Flatforum" \
-x \*.sh \*.directory \*.project \*.settings \*.buildpath 



#LINGUA ----------------
namepack=$pwd"-blocks-Lingua-"$(date +"%Y-%m.%d")
zip -r $namepack.zip \
$pwd"/blocks/dx/05_Lingua.php" $pwd"/blocks/dx/Lingua.php.xml" \
-x \*.sh \*.directory \*.project \*.settings \*.buildpath 


#Accesskey ----------------
namepack=$pwd"-blocks-Accesskey-"$(date +"%Y-%m.%d")
zip -r $namepack.zip \
$pwd"/blocks/dx/30_Accesskey.php" $pwd"/blocks/dx/Accesskey.php.xml" \
-x \*.sh \*.directory \*.project \*.settings \*.buildpath 
cd $oldpwd
