<?php
/**
 * Flatnux config
 * 
 * @package Flatnux
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 */
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	header("Location:../index.php");
	die("...");
}

#[it]Titolo del sito
#[en]Site Title
$sitename="Home page";

#[it]Keywords del sito
#[en]Keywords
$keywords="Headlines, headlines, FlatNux, flatnux, Download, download, Downloads, downloads, Forum, forum, Comment, comment, Comments, comments";

#[it]Tema preferito{./themes}
#[en]Default theme{./themes}
$theme="base";

#[it]Nome Amministratore
#[en]Name Administrator
$admin="Me";

#[it]E-mail amministratore
#[en]Administrator mail
$admin_mail="nobody@null.null";

#[it]Lingua di default{languages/*.php,auto=automatic}}
#[en]Default language{languages/*.php,auto=automatic}
$lang="it";

#[it]Url del sito (vuoto per autorilevamento)
#[en]Site url (empty = autodetect)
$siteurl = "";

#[it]Fuso orario
#[en]jet lag
$jet_lag=0;

#[it]Lingue contenuti, valori separati da virgola (es.it,en,es)
#[en]Contents languages (eg.it,en,es)
$languages = "it,en,es,de,fr";

#[it]Se non esiste traduzione visualizza pagina in altre lingue{1=SI,0=NO}
#[en]If translation does not exist it visualizes page in other languages{1=YES,0=NO}
$lang_auto_switch = 1;

#[it]Editor html{0=Disabilitato,include/extra}
#[en]Editor html{0=Disable,include/extra}
$htmleditor = "fck3";

#[it]Registrazione tramite email {1=SI,0=NO}
#[en]Registration through email {1=YES,0=NO}
$registration_by_email=1;

#[it]Invia email di log all' amministratore {1=SI,0=NO}
#[en]Enable LOG email to administrator{1=YES,0=NO}
$enable_log_email = 0;

#[it]Indirizzo email a cui vengono inviati i log
#[en]E-mail address to which they come sendes the log to you
$log_email_address="nobody@null.null";

#[it]Indirizzo email con cui i messaggi vengono inviati
#[en]Server e-mail address
$site_email_address="nobody@null.null";

#[it]Sezione predefinita{0=Disabilitato,./sections}
#[en]Default section{0=Disabilitato,./sections}
$home_section = "news";

#[it]Visualizza il messaggio di benvenuto {1=SI,0=NO}
#[en]Show welcome message  {1=YES,0=NO}
$show_welcome_message = 1;


#[it]Visualizza gli accesskey accanto al link {1=SI,0=NO}
#[en]Show acces key {1=YES,0=NO}
$showaccesskey = 0;


#[it]Sito in manutenzione {1=SI,0=NO}
#[en]Site in maintenance {1=YES,0=NO}
$maintenance = 0;


#[it]Visualizza 'ricorda login'{1=SI,0=NO}
#[en]Show 'remember login'{1=SI,0=NO}
$remember_login=1;


#[it]Syntax highlighting durante la modifica dei files {1=SI,0=NO}
#[en]Enable syntax highlighting{1=YES,0=NO}
$syntax_highlighting=1;


#[it]Cartella scrivibile che contiene i dati (default=misc)
#[en]Enable syntax highlighting (default=misc)
$fn_datadir="misc";


#[it]Abilita registrazione utenti{1=SI,0=NO}
#[en]Enable user registration {1=YES,0=NO}
$enable_registration=1;

#[it]Permetti eliminazione account {1=SI,0=NO}
#[en]Allows account deletion {1=YES,0=NO}
$enable_account_deletion=0; 

#[it]Comprimi pagina con gzip {1=SI,0=NO}
#[it]Compress pages with gzip {1=SI,0=NO}
$enable_compress_gzip=0;

#[it]Permetti amministrazione online {1=SI,0=NO}
#[en]Allows online administration {1=YES,0=NO}
$enable_online_administration=1;


//non rimuovere !!!
//not to remove !!!
include ('include/dynamic.php');
?>