<?php
/**
 * 
 * @package Flatnux
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 * Semplicissimo editor html composto da una textarea e da una anteprima del testo digitato
 */
global $hpath, $hshowtoolbar;
//----conf --------
$hpath = "include/extra/textarea/";
$hshowtoolbar = true;
function showhtmlarea($name, $cols, $rows, $text = "")
{
	global $hpath, $hshowtoolbar, $syntax_highlighting;
	if ($hshowtoolbar)
	{
		toolbar_js($name);
		html_panel($name, "formatting");
	}
	$st = "";
	if ($cols == "")
	{
		$cols = 80;
		$st = "style=\"width:100%;\"";
	}
	echo "<p style=\"text-align:left;\">
		 <textarea $st onkeyup='UpdatePreview$name();' onchange='UpdatePreview$name();' name='$name' id='__$name' cols='$cols' rows='$rows' >" . htmlspecialchars($text) . "</textarea>
		</p>";
	if (false && $syntax_highlighting == "1")
	{
?>

<script language='javascript' type="text/javascript" src="include/codepress/codepress.js" >
</script>
<script language='javascript' type="text/javascript" >
codepressReplaceTextarea('include/codepress/',"__<?php echo $name?>",'html');
</script>
<?php

	}
?>

<!--<div title="_<?php echo $name?>" id="_<?php echo $name?>" align="left" style="height:80;width:100%;overflow:auto;font-size:x-small;"></div>-->
<br />
<?php echo _ANTEPRIMA?>:<br /><br />
<p>
<div title="_<?php echo $name?>" id="_<?php echo $name?>" align="left"></div>
</p>
&nbsp;&nbsp;

<script language="JavaScript">
	UpdatePreview<?php echo $name?>();
	function UpdatePreview<?php echo $name?>()
	{
		res=document.getElementById("__<?php echo $name?>");
		document.getElementById("_<?php echo $name?>").innerHTML=res.value;
		//_<?php echo $name?>.innerHTML=res.value;
	}
</script>

<?php


}
function toolbar_js($name)
{
	echo "";
	echo "\n\n<script language='javascript' type='text/javascript'>
function insertTags" . $name . "(tag1, tag2, area) {
	var txta = document.getElementsByName(area)[0];
	txta.focus();
	if (document.selection) {
		var sel  = document.selection.createRange();
		sel.text = tag2
			? tag1 + sel.text + tag2
			: tag1;
	}
	else if (txta.selectionStart != undefined) {
		var before = txta.value.substring(0, txta.selectionStart);
		var sel    = txta.value.substring(txta.selectionStart, txta.selectionEnd);
		var after  = txta.value.substring(txta.selectionEnd, txta.textLength);
		txta.value = tag2
			? before + tag1 + sel + tag2 + after
			: before + \"\" + tag1 + \"\" + after;
	}
	UpdatePreview" . $name . "();
	}

</script>\n\n";
}
function html_panel($area, $what)
{
	global $lang, $hpath;
	// verifico provenienza della chiamata e adatto i richiami alle directories
	$prepath = fromtheme("images/emoticon/red.png");
	// stampo la parte di pannello selezionata
	switch ($what)
	{
		case "formatting" :
?>
		<img onclick="javascript:insertTags<?php echo $area?>('<b>', '</b>', '<?php echo $area?>')" onmouseover="document.getElementsByName('<?php echo $area?>')[0].focus()" src="<?php echo "$hpath/images/bold.gif"?>" border="0" alt="bold" title="bold" style="cursor: pointer;" />
		<img onclick="javascript:insertTags<?php echo $area?>('<em>', '</em>', '<?php echo $area?>')" onmouseover="document.getElementsByName('<?php echo $area?>')[0].focus()" src="<?php echo "$hpath/images/italic.gif"?>" border="0" alt="italic" title="italic" style="cursor: pointer;" />
		<img onclick="javascript:insertTags<?php echo $area?>('<u>', '</u>', '<?php echo $area?>')" onmouseover="document.getElementsByName('<?php echo $area?>')[0].focus()" src="<?php echo "$hpath/images/underline.gif"?>" border="0" alt="underline" title="underline" style="cursor: pointer;" />
		<img onclick="javascript:insertTags<?php echo $area?>('<pre>', '</pre>', '<?php echo $area?>')" onmouseover="document.getElementsByName('<?php echo $area?>')[0].focus()" src="<?php echo "$hpath/images/code.gif"?>" border="0" alt="code" title="code" style="cursor: pointer;" />
		<img onclick="javascript:insertTags<?php echo $area?>('<br />', '', '<?php echo $area?>')" onmouseover="document.getElementsByName('<?php echo $area?>')[0].focus()" src="<?php echo "$hpath/images/br.gif"?>" border="0" alt="br" title="br" style="cursor: pointer;" />
		<?php


			break;
	}
}
?>