<?php
/**
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2009
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 * @package xmldb
 * 
 */
/**
 * edid xml tables
 * 
 * @param $tablename
 * @param $dbname
 * @param $params
 * @return unknown_type
 */
function XMLDB_editor($tablename, $dbname, $params = false)
{
	//--parametri ---->
	$html = "";
	//dprint_r($params);
	//global $postgetkey;
	$tname=$tablename;
	if (  is_array($tablename) )
	{
		if (isset($tablename['tablename']))
		{
			$tname=$tablename['tablename'];
		}
		else
		{
			die ("tablename is not set");
		}
	}

	$postgetkey = "__xdb_{$tname}"; //identificatico della tabella
	$functioninsert = isset($params['functioninsert']) ? $params['functioninsert'] : "";
	$echo = isset($params['echo']) ? $params['echo'] : true;
	$path = isset($params['path']) ? $params['path'] : "";
	$lang = isset($params['lang']) ? $params['lang'] : "en";
	$languages = isset($params['languages']) ? $params['languages'] : "en";
	$restr = isset($params['restr']) ? $params['restr'] : false;
	$restr = isset($params['filters']) ? $params['filters'] : $restr;

	$table = isset($params['table']) ? $params['table'] : false;
	$fields = isset($params['fields']) ? $params['fields'] : false;
	$functionsview = isset($params['functionsview']) ? $params['functionsview'] : false;
	$show_translations = isset($params['show_translations']) ? $params['show_translations'] : false;
	$bgcolor = isset($params['bkrow']) ? $params['bkrow'] : "#ffffff";
	$bgcolor2 = isset($params['bkrow2']) ? $params['bkrow2'] : "#f0f0f0";
	$bgcolorover = isset($params['bgcolorover']) ? $params['bgcolorover'] : "#ffff00";

	$backgroundcolorheader = isset($params['bkheader']) ? $params['bkheader'] : "#e1eaef";
	$bordercolor = isset($params['bordercolor']) ? $params['bordercolor'] : "#000000";
	$textcolor = isset($params['textcolor']) ? $params['textcolor'] : "#000000";
	$linkcolor = isset($params['linkcolor']) ? $params['linkcolor'] : "#000000";
	$flink = isset($params['link']) ? $params['link'] : "";
	$flink_listmode = isset($params['link_listmode']) ? $params['link_listmode'] : $params['link'];
	$enableview = isset($params['enableview']) ? $params['enableview'] : false;
	$enabledelete = isset($params['enabledelete']) ? $params['enabledelete'] : true;
	$enableedit = isset($params['enableedit']) ? $params['enableedit'] : true;
	$enablenew = isset($params['enablenew']) ? $params['enablenew'] : true;
	$defaultorder = isset($params['defaultorder']) ? $params['defaultorder'] : false;
	$reverse =  isset($params['defaultorderdesc']) ? $params['defaultorderdesc'] : false;
	$oninsert = isset($params['oninsert']) ? $params['oninsert'] : "";
	$onupdate = isset($params['onupdate']) ? $params['onupdate'] : "";
	//force values
	$forcevalues = isset($params['forcevalues']) ? $params['forcevalues'] : false;
	$forcevalues = isset($params['forcefieldvalues']) ? $params['forcefieldvalues'] : $forcevalues;
	//force in insert
	$forcevaluesinsert = isset($params['forcevaluesinsert']) ? $params['forcevaluesinsert'] : false;
	//force in update
	$forcevaluesupdate = isset($params['forcevaluesupdate']) ? $params['forcevaluesupdate'] : false;
	//force in form insert
	$forcenewvalues = isset($params['forcenewvalues']) ? $params['forcenewvalues'] : true;
	//force in form update
	$forceupdatevalues = isset($params['forceupdatevalues']) ? $params['forceupdatevalues'] : true;
	$recordsperpage = isset($params['recordsperpage']) ? $params['recordsperpage'] : false;
	$textrequired = isset($params['textrequired']) ? $params['textrequired'] : "*";
	$textfields = isset($params['textfields']) ? $params['textfields'] : "<legend>" . "*=required fields" . "</legend><br />";
	$textfields = str_replace("*", $textrequired, $textfields);
	$textsave = isset($params['textsave']) ? $params['textsave'] : "salva";
	$textnorecord = isset($params['textnorecord']) ? $params['textnorecord'] : "no records found";
	$optionsedit = array();
	if ( $enableview )
		$optionsedit[] = "view";
	if ( $enableedit )
		$optionsedit[] = "edit";
	if ( $enabledelete )
		$optionsedit[] = "delete";
	$textcancel = isset($params['textcancel']) ? $params['textcancel'] : "Cancel";
	$textnew = isset($params['textnew']) ? $params['textnew'] : "[ new ]";
	$textinsertok = isset($params['textinsertok']) ? $params['textinsertok'] : "The data were successfully inserted";
	$textupdateok = isset($params['textupdateok']) ? $params['textupdateok'] : "The data were successfully updated";
	$textinsertfail = isset($params['textinsertfail']) ? $params['textinsertfail'] : "Error insert record";
	$textviewlist = isset($params['textviewlist']) ? $params['textviewlist'] : "&lt;&lt;&nbsp;" . "back" . "";
	$textpages = isset($params['textpages']) ? $params['textpages'] : "Pages :";
	$textview = isset($params['textview']) ? $params['textview'] : "view";
	$textmodify = isset($params['textmodify']) ? $params['textmodify'] : "modify";
	$textdelete = isset($params['textdelete']) ? $params['textdelete'] : "delete";

	//--parametri ----<
	//-----variabili da get --------->
	$opmod = isset($_GET["op_$postgetkey"]) ? htmlspecialchars($_GET["op_$postgetkey"]) : "";
	$pk = isset($_GET["pk_$postgetkey"]) ? htmlspecialchars($_GET["pk_$postgetkey"]) : "";
	$page = isset($_GET["page_$postgetkey"]) ? htmlspecialchars($_GET["page_$postgetkey"]) : "";
	$order = isset($_GET["order_$postgetkey"]) ? htmlspecialchars($_GET["order_$postgetkey"]) : "";
	//-----variabili da get ---------<
	$tlink = "";
	$mlink = "&amp;page_$postgetkey=$page";
	if ( is_array($forcevalues) )
		foreach ( $forcevalues as $key => $value )
		{
			$tlink .= "&amp;" . $key . "=" . $value;
			$mlink .= "&amp;" . $key . "=" . $value;
		}
	if ( $flink != "" )
	{
		$tlink .= "&amp;$flink";
		$mlink .= "&amp;$flink";
	}
	//-----tabella --------->
	if ( !is_object($table) )
		$table = new FieldForm("$dbname", $tablename, $path, $lang, $languages);
	$table->setlayoutTags("<b>", ":</b>", "<br />", "<br /><br />", "<fieldset><legend>", "</legend>", "", "</fieldset>");
	//filtro sulle foreignkey---->
	if ( isset($params['restrfk']) && $params['restrfk'] != "" )
	{
		if ( is_array($params['restrfk']) )
		{
			foreach ( $params['restrfk'] as $k => $v )
			{
				if ( isset($table->formvals[$k]) )
				{
					$table->formvals[$k]['fk_filter_field'] = $v;
				}
			}
		}
		else
		{
			foreach ( $table->formvals as $k => $v )
			{
				if ( isset($table->formvals[$k]['foreignkey']) )
				{
					$table->formvals[$k]['fk_filter_field'] = $params['restrfk'];
				}
			}
		}
	}
	//filtro sulle foreignkey----<
	//-----tabella --------->
	$toupdate = false;
	//----eliminazione del record
	if ( $enabledelete && $opmod == "del" )
		$table->xmltable->DelRecord($pk);
	switch ( $opmod )
	{
		//-------inserimento/aggiornamento record  --------->
		case "insnew" :
			$newvalues = $table->getbypost();
			if ( is_array($forcevalues) )
			{
				foreach ( $forcevalues as $k => $v )
				{
					$newvalues[$k] = $v;
				}
			}

			if ( $pk != "" )
			{
				$toupdate = true; //se esiste la chiave primaria il record  da aggiornare
			}

			if ( $toupdate && is_array($forcevaluesupdate) )
			{
				foreach ( $forcevaluesupdate as $k => $v )
				{
					$newvalues[$k] = $v;
				}
			}
			if ( !$toupdate && is_array($forcevaluesinsert) )
			{
				foreach ( $forcevaluesinsert as $k => $v )
				{
					$newvalues[$k] = $v;
				}
			}
			if ( $toupdate && !$enableedit )
				break;
			if ( !$toupdate && !$enablenew )
				break;
			if ( isset($_POST["save_$postgetkey"]) )
			{
				if ( isset($_POST[$table->xmltable->primarykey]) )
				{
					if ( $table->xmltable->GetRecordByPk($_POST[$table->xmltable->primarykey]) )
					{
						$toupdate = true;
					}
				}
				$errors = $table->VerifyExt($newvalues, $toupdate);
				//dprint_r($errors);
				//echo " salvo{$_POST[$table->xmltable->primarykey]}";
				if ( is_array($errors) && count($errors) > 0 )
				{
					foreach ( $errors as $field => $error )
					{
						$table->setlayoutTag($field, "<b>", ":</b>&nbsp;<span style=\"background-color:#ffffff;color:red\">{$error['error']}</span>", "<br />", "<br /><br />", "<fieldset><legend>", "</legend>", "", "</fieldset>");
					}
				}
				else
				{
					if ( $toupdate )
					{
						//dprint_r($newvalues);
						$newvalues = $table->xmltable->UpdateRecord($newvalues);
						if ( $onupdate != "" )
						{
							$html .= $onupdate;
							break;
						}
						//dprint_r($newvalues);
						if ( $newvalues )
							jsalert($textupdateok);
						else
							jsalert($textinsertfail);
					}
					else
					{
						//echo "Inserisco";
						$newvalues = $table->xmltable->InsertRecord($newvalues);

						$pk = $newvalues[$table->xmltable->primarykey];
						if ( $oninsert != "" )
						{
							$html .= $oninsert;
							break;
						}
						jsalert($textinsertok);
						$toupdate = true;
					}
				}
			}
			$html .= "<fieldset>$textfields";
			$html .= "<form enctype=\"multipart/form-data\" action=\"?page_$postgetkey=$page&amp;order_$postgetkey=$order&amp;pk_{$postgetkey}=$pk&amp;op_$postgetkey=insnew$tlink\" method=\"post\"><div>\n";
			if ( $toupdate )
			{
				$html .= "UPDATE<br />";
				//dprint_r($_POST);
				if ( is_array($forceupdatevalues) )
					foreach ( $forceupdatevalues as $fok => $fov )
					{
						if ( !isset($_POST[$fok]) )
						{
							$newvalues[$fok] = $fov;
						}
					}

				ob_start();
				$table->ShowUpdateForm($pk, is_admin(), $newvalues);
				$html .= ob_get_clean();
			}
			else
			{
				if ( is_array($forcenewvalues) )
					foreach ( $forcenewvalues as $fok => $fov )
					{
						if ( !isset($_POST[$fok]) )
						{
							$newvalues[$fok] = $fov;
						}
					}
				//echo "NEW<br />";
				ob_start();
				$table->ShowInsertForm(is_admin(), $newvalues);
				$html .= ob_get_clean();
			}
			if ( $functioninsert != "" && function_exists($functioninsert) )
			{
				ob_start();
				$functioninsert($newvalues);
				$html .= ob_get_clean();
			}
			$html .= "<br /><input name=\"save_$postgetkey\" type=\"submit\" class=\"submit\" value=\"" . $textsave . "\" />";
			$html .= "&nbsp;<input type=\"button\" onclick=\"window.location='?" . str_replace("&amp;", "&", $tlink) . "'\" class=\"submit\" value=\"" . $textcancel . "\" />";
			$html .= "\n</div></form></fieldset>";
			$html .= "<br /><a style=\"color:$linkcolor\" href=\"?page_$postgetkey=$page&amp;order_$postgetkey=$order&amp;$flink_listmode\">$textviewlist</a><br /><br />";
			break;
		//-------inserimento/aggiornamento record  ---------<
		case "view" :
			$html .= xmldb_view($pk, $tablename, $dbname, $path, $lang, $languages);
			$html .= "<br /><br /><a style=\"color:$linkcolor\" href=\"?page_$postgetkey=$page&amp;order_$postgetkey=$order&amp;$flink_listmode\">$textviewlist</a><br /><br />";
			break;
		default :
			$fieldstoread = $__fieldstoread = false;
			if ( $fields != false && !is_array($fields) )
			{
				$fields = explode("|", $fields);
				$__fieldstoread = $fields;
				if ( !isset($__fieldstoread[$table->xmltable->primarykey]) )
				{
					$__fieldstoread[] = $table->xmltable->primarykey;
				}
			}
			if ($__fieldstoread)
			{
				foreach ($__fieldstoread as $fieldname)
				{
					if (isset($table->xmltable->fields[$fieldname]))
					{
						$fieldstoread[]=$fieldname;
					}
				}
			}
			if ( $defaultorder == false )
				$defaultorder = $table->xmltable->primarykey;
			if ( $order == false )
				$order = $defaultorder;
			//echo "or=$order";
			if ( $recordsperpage != false )
			{
				if ( $page == "" )
					$page = 1;
				$num_records = $table->xmltable->GetNumRecords($restr);
				//echo "num_records=$num_records ";
				$numPages = ceil($num_records / $recordsperpage);
				if ( $page > $numPages )
					$page = $numPages;
				$start = ($page * $recordsperpage - $recordsperpage) + 1;
				$end = $start + $recordsperpage - 1;
			}
			else
			{
				$start = false;
			}
			//die ("ds");
			if ( $order == false )
			{
				$all = $table->xmltable->GetRecords($restr, $start, $recordsperpage, $order, $reverse, $fieldstoread);
			}
			else
			{
				$all = $table->xmltable->GetRecords($restr, false, false, false, false, $fieldstoread);
			}
			if ( $recordsperpage && $numPages > 1 )
			{
				$html .= $textpages;
				for ( $i = 1; $i <= $numPages; $i++ )
				{
					if ( $page == $i )
						$html .= " <a style=\"color:$linkcolor\" href=\"?$tlink&amp;page_{$postgetkey}=$i&amp;order_{$postgetkey}=$order\"><b>$i</b></a>";
					else
						$html .= " <a style=\"color:$linkcolor\" href=\"?$tlink&amp;page_{$postgetkey}=$i&amp;order_{$postgetkey}=$order\">$i</a>";
				}
			}
			if ( $order != false )
			{
				if ( is_array($all) )
					$all = xmldb_array_natsort_by_key($all, str_replace("{$postgetkey}", "", $order));
			}
			echo "
<script type=\"text/javascript\">
trh = function (over,elem){
	var old;
	if (over){
		this.old = elem.style.backgroundColor ;
		elem.style.backgroundColor='$bgcolorover';
	}
	else{
		elem.style.backgroundColor=this.old;
	}
}
</script>
";

			$html .= "<table style=\"background-color:$bordercolor\" cellpadding=\"2\" cellspacing=\"1\" >";
			$html .= "<tr >";
			$orderfield = array();
			if ( $fields )
			{
				foreach ( $fields as $ofield )
				{
					if ( isset($table->formvals[$ofield]) )
					{
						$orderfield[$ofield] = $table->formvals[$ofield];
					}
					else
					{
						$orderfield[$ofield] = "";
					}
				}
			}
			else
				$orderfield = $table->formvals;
			$numcols = 0;
			foreach ( $orderfield as $key => $value )
			{
				if ( $fields && !in_array($key, $fields) )
				{
					continue;
				}
				if ( $show_translations == true || !isset($table->formvals[$key]['frm_multilanguage']) || $table->formvals[$key]['frm_multilanguage'] != "1" )
				{
					$numcols++;
					if (isset($value['title']))
						$html .= "<td style=\"background-color:$backgroundcolorheader;font-weight:bold;color:$textcolor\" ><a style=\"color:$linkcolor\" href=\"?order_{$postgetkey}=$key&amp;$tlink\">" . $value['title'] . "</a></td>";
					else
						$html .= "<td style=\"background-color:$backgroundcolorheader;font-weight:bold;color:$textcolor\" ></td>";

				}
			}
			$colspan = count($optionsedit);
			if ( $colspan > 0 )
			{
				$numcols+=3;
				$html .= "<td style=\"background-color:$backgroundcolorheader;color:$textcolor\" colspan=\"3\">&nbsp;</td>";
			}
			$html .= "</tr>";
			$i = 0;
			static $tablefk = array();
			if ( is_array($all) && count($all) > 0 )
			{
				foreach ( $all as $row )
				{
					$backgroundcolor = ($i % 2 == 0) ? $bgcolor : $bgcolor2;
					$i++;
					//start - end --->
					if ( $recordsperpage != false && ($i < $start || $i > $end) )
						continue;
					//start -end ---<
					$html .= "<tr style=\"background-color:$backgroundcolor;color:$textcolor\" onmouseover=\"trh(1,this)\" onmouseout=\"trh(0,this)\" >";
					foreach ( $orderfield as $key => $field )
					{
						$kfunction = (false !==  strpos($key, "()")) ? str_replace("()","",$key):false;
						if ( $fields && !in_array($key, $fields) )
							continue;
						$vimage = "";
						if ( $show_translations == true || !isset($table->formvals[$key]['frm_multilanguage']) || $table->formvals[$key]['frm_multilanguage'] != "1" )
						{
							if ( isset($functionsview[$key]) )
							{
								$value = $functionsview[$key]($row[$field['name']]);
							}
							elseif (function_exists($kfunction))
							{
								$value = $kfunction($row[$table->xmltable->primarykey]);
							}
							elseif(!isset($field['name']))
							{
								$value="";
							}
							else
							{

								$value = $row[$field['name']];
								//print_r($field);
								if ( $field['frm_type'] == "image" )
								{
									$image = $table->xmltable->get_file($row, $field['name']);
									if ( $image != "" )
									{
										$himage = 16;
										if ( isset($params['imagesize']) )
										{
											$himage = $params['imagesize'];
										}
										$image = dirname($image) . "/thumbs/" . basename($image) . ".jpg";
										$vimage = "<img src=\"" . $image . "\" height=\"$himage\" />";
										$value = "";
									}
								}
								if ( isset($field['foreignkey']) && isset($field['fk_show_field']) )
								{
									$r = array();
									$tfk[$field['fk_link_field']] = xmldb_table($dbname, $field['foreignkey'], $path);
									$tablefk = $tfk[$field['fk_link_field']];
									$f = $field['fk_link_field'];
									if ( $field['fk_link_field'] != $field['fk_show_field'] )
									{
										$f.= "|" . $field['fk_show_field'];
									}
									if ( isset($tfk[$field['fk_link_field']]->fields[$field['fk_link_field'] . "_{$lang}"]) )
										$f .= "|" . $field['fk_show_field'] . "_{$_FN['lang']}";
									//echo $f;

									$r[$field['fk_link_field']] = $row[$field['name']];
									//dprint_r($value);
									$showfields = explode(",", $field['fk_show_field']);
									$value = "";
									$sep = "";
									foreach ( $showfields as $showfield )
									{
										$tvalue = $tablefk->GetRecord(array($field['fk_link_field'] => $row[$field['name']]));
										if ( isset($tvalue["{$showfield}_{$lang}"]) && $tvalue["{$showfield}_{$lang}"] != "" )
											$value .=$sep . $tvalue["{$showfield}_{$lang}"];
										elseif ( isset($tvalue["{$showfield}_en"]) && $tvalue["{$showfield}_en"] != "" )
											$value .=$sep . $tvalue[$showfield . "_en"];
										else
											$value .=$sep . $tvalue[$showfield];
										$sep = "-";
									}
								}
								else
								{
									if ( isset($field['options']) && is_array($field['options']) )
									{
										foreach ( $field['options'] as $opt )
										{
											if ( $row[$field['name']] == $opt['value'] )
												$value = $opt['title'];
										}
									}
								}
								$value = substr(strip_tags($value), 0, 40);
								//dprint_r($vs);
							}
							$html .= "<td  style=\"background-color:transparent;color:$textcolor\" >$vimage" . $value . "</td>";
							/*if (!empty($params['columns']))
							{
								$columns = explode(",",$params['columns']);
								foreach ($columns as $column )
								{
									if (  function_exists($column))
									{
										$column($row[$table->xmltable->primarykey]);
									}
								}
							}

							 */
						}
					}
					if ( $enableview && $numcols++ )
						$html .= "<td style=\"background-color:transparent;color:$textcolor\"><a style=\"color:$linkcolor\" href=\"?page_$postgetkey=$page&amp;order_$postgetkey=$order&amp;op_$postgetkey=view&amp;pk_{$postgetkey}=" . $row[$table->xmltable->primarykey] . "$mlink\">" . $textview . "</a></td>";
					if ( $enableedit && $numcols++ )
						$html .= "<td style=\"background-color:transparent;color:$textcolor\"><a style=\"color:$linkcolor\" href=\"?page_$postgetkey=$page&amp;order_$postgetkey=$order&amp;op_$postgetkey=insnew&amp;pk_{$postgetkey}=" . $row[$table->xmltable->primarykey] . "$mlink\">" . $textmodify . "</a></td>";
					if ( $enabledelete && $numcols++ )
						$html .= "<td style=\"background-color:transparent;color:$textcolor\"><a style=\"color:$linkcolor\" href=\"javascript:check('?page_$postgetkey=$page&order_$postgetkey=$order&op_$postgetkey=del&amp;pk_$postgetkey=" . $row[$table->xmltable->primarykey] . "&$flink_listmode');\">" . $textdelete . "</a></td>";
					$html .= "</tr>";
				}
			}
			else
			{
				//$html = "<table border=\"\" style=\"background-color:$bordercolor\" cellpadding=\"2\" cellspacing=\"1\" >";
				$html .= "<tr><td style=\"background-color:$bgcolor;color:$textcolor\" colspan=\"$numcols\">$textnorecord</td></tr>";
			}
			$html .= "</table>";
			if ( $enablenew )
				$html .= "<a style=\"color:$linkcolor\" href=\"?page_$postgetkey=$page&amp;order_$postgetkey=$order&amp;op_{$postgetkey}=insnew$mlink\">$textnew</a>";
			break;
	}
	if ( $echo == true )
		echo $html;
	//dprint_r($_POST);
	return $html;
}
/**
 * 
 * @param array $array
 * @param string $order
 * @param bool $desc
 */
function _xmldb_array_natsort_by_key($array, $order, $desc = false)
{
	$ret = $array;
	$newret = array();
	foreach ( $ret as $key => $value )
	{
		if ( isset($value[$order]) )
		{
			$i = $desc ? 99999999 : 0;
			$r = $value[$order];
			while ( isset($newret[$r . $i]) )
			{
				if ( $desc )
					$i--;
				else
					$i++;
			}
			$newret[$r . $i] = $ret[$key];
		}
		else
		{
			$i = $desc ? 99999999 : 0;
			$r = "";
			while ( isset($newret[$r . $i]) )
			{
				if ( $desc )
					$i--;
				else
					$i++;
			}
			$newret[$r . $i] = $ret[$key];
		}
	}
	//----era cc_natkcasesort ( $newret ); ---->
	$keys = array_keys($newret);
	$new_array = array();
	natcasesort($keys);
	foreach ( $keys as $k )
	{
		$new_array[$k] = $newret[$k];
	}
	$newret = $new_array;
	//----era cc_natkcasesort ( $newret ); ----<
	if ( $desc == true )
	{
		$newret = array_reverse($newret);
	}
	return $newret;
}
/**
 * 
 * @param string $unirecid
 * @param string $tablename
 * @param string $databasename
 * @param string $path
 * @param string $lang
 * @param string $languages
 */
function xmldb_view($unirecid, $tablename, $databasename, $path, $lang, $languages, $params = false)
{
	global $_FN;
	$params['link'] = isset($params['link']) ? $params['link'] : "";
	$Table = new FieldForm("$databasename", $tablename, $path, $lang, $languages);
	$row = $Table->xmltable->GetRecordByPrimaryKey($unirecid);
	$unirecid = isset($row['unirecid']) ? $row['unirecid'] : false;
	$htmlout = "";
	//dprint_r($Table->formvals);
	//dprint_r($row);
	$view_endgroup = "";
	foreach ( $Table->formvals as $field )
	{
		if ( isset($field['view_enabledgroups']) && $field['view_enabledgroups'] != "" )
		{
			if ( !is_admin() && !user_in_group($_FN['user'], $field['view_enabledgroups']) )
				continue;
		}
		if ( isset($field['view_group']) )
		{
			$htmlout .= "\n<div class=\"xmldbgroup{$field['view_group']}\">";
		}
		$beforetitle = isset($field['view_beforetitle']) ? $field['view_beforetitle'] : "";
		$aftertitle = isset($field['view_aftertitle']) ? $field['view_aftertitle'] : ":";
		$beforevalue = isset($field['view_beforevalue']) ? $field['view_beforevalue'] : "";
		$aftervalue = isset($field['view_aftervalue']) ? $field['view_aftervalue'] : "";
		$title = "";
		if ( $field['title'] != '' )
		{
			$title = "$beforetitle" . $field['title'] . "$aftertitle";
		}
		//se e la traduzione di un campo
		if ( isset($field['frm_multilanguage']) && $field['frm_multilanguage'] == 1 )
		{
			continue;
		}
		if ( isset($Table->formvals[$field['name'] . "_{$lang}"]) )
		{
			$value = isset($row[$field['name'] . "_{$lang}"]) ? $row[$field['name'] . "_{$_FN['lang']}"] : "";
			if ( $value == "" )
				$value = isset($row[$field['name']]) ? $row[$field['name']] : "";
		}
		else
		{
			$value = isset($row[$field['name']]) ? $row[$field['name']] : "";
		}
		if ( !isset($field['frm_showinpage']) || $field['frm_showinpage'] |= 0 )
			if ( $value != "" && (!isset($field['frm_show']) || $field['frm_show'] != 0) )
			{
				if ( isset($field['foreignkey']) && isset($field['fk_show_field']) )
				{
					$r = array();
					$f = array();
					$tablefk = new XMLTable($databasename, $field['foreignkey'], $path);
					$tf = explode(",", $field['fk_show_field']);
					$f[$field['fk_link_field']] = $field['fk_link_field'];
					foreach ( $tf as $ttf )
					{
						if ( $ttf != "" )
							$f[$ttf] = $ttf;
						if ( isset($tablefk->fields[$ttf . "_{$lang}"]) )
							$f[$ttf . "_{$lang}"] = $ttf . "_{$lang}";
					}
					$f = implode("|", $f);
					$r[$field['fk_link_field']] = $row[$field['name']];
					$vs = $tablefk->GetRecords($r, false, false, false, false, $f);
					$value = isset($vs[0]) ? $vs[0] : null;
					$tit = "";
					$sep = "";
					foreach ( $tf as $ttf )
					{
						if ( isset($tablefk->fields[$ttf . "_{$lang}"]) && $value[$ttf . "_{$lang}"] != "" )
							$tit .= $sep . $value[$ttf];
						else
							$tit .= $sep . $value[$ttf];
						$sep = " - ";
					}
					$value = $tit;
				}
				$st = $et = "";
				if ( isset($field['view_tag']) && $field['view_tag'] != "" )
				{
					$st = "<" . $field['view_tag'] . ">";
					$et = "</" . $field['view_tag'] . ">";
				}
				if ( isset($field['view_hiddentitle']) && $field['view_hiddentitle'] = 1 )
				{
					$title = "";
				}
				else
				{
					if ( isset($field['view_titletag']) && $field['view_titletag'] != "" )
					{
						$title = "<" . $field['view_titletag'] . ">" . $title . "</" . $field['view_titletag'] . ">";
					}
					if ( isset($field['iconview']) && $field['iconview'] != "" )
					{
						$title = "<img alt='' border='0' src='" . $field['iconview'] . "' /> $title";
					}
				}
				//---------------------------------valori---------------------->
				$htmlout .= "\n<span class=\"xmldbcontent xmldbcontent{$field ['frm_type']} xmldbcontent{$field ['name']} \">";
				$et = $aftervalue . $et;
				if ( $title == "" )
				{
					// se non ha il titolo (st span type-value VALUE /span /et)
					$st = "<span class=\"xmldbvalue xmldbvaluetype{$field ['frm_type']} xmldbvalue{$field ['name']}\">$st";
					$et .= "</span><!-- \n end title -->";
				}
				else
				{
					$htmlout .= "<span class=\"xmldbtitle xmldbtitletype{$field ['frm_type']} xmldbtitle{$field ['name']} \">$st$title</span>";
					$st = "";
					$title = "";
					$htmlout .= "<span class=\"xmldbvaluetype xmldbvaluetype{$field ['frm_type']} xmldbvalue{$field ['name']} \">$beforevalue";
				}
				//dprint_r($Table);
				switch ( $field['frm_type'] )
				{
					case "image" :
						$tablepath = $Table->xmltable->FindFolderTable($row);
						$fileimage = isset($row[$Table->xmltable->primarykey]) ? "$path/$databasename/$tablepath/" . $row[$Table->xmltable->primarykey] . "/" . $field['name'] . "/" . $row[$field['name']] : "";
						$filethumb = isset($row[$Table->xmltable->primarykey]) ? "$path/$databasename/$tablepath/" . $row[$Table->xmltable->primarykey] . "/" . $field['name'] . "/thumbs/" . $row[$field['name']] . ".jpg" : "";
						//echo "$fileimage";
						$ww = $hh = $field['thumbsize'];
						if ( isset($field['thumbsize_w']) )
						{
							$ww = $field['thumbsize_w'];
						}
						if ( isset($field['thumbsize_h']) )
						{
							$hh = $field['thumbsize_h'];
						}
						//if (file_exists ( "thumb.php" ))
						//	$filethumb = isset ( $row ['unirecid'] ) ? "thumb.php?d=$databasename&amp;t=$tablename&amp;i=" . $row ['unirecid'] . "&amp;h=$hh&amp;w=$ww&amp;c=" . $field ['name'] : "";
						if ( $fileimage != "" && file_exists($fileimage) )
						{
							$htmlout .= "\n$st<a href=\"$fileimage\" onclick=\"window.open(this.href);return false;\" ><img alt=\"\"";
							$htmlout .= tooltip(fn_i18n("_CLICKONTHEPHOTO"));
							$htmlout .= " border=\"0\" src=\"$filethumb\" /></a>$et<br />";
						}
						else
						{
							if ( $fileimage != "" && file_exists($fileimage) )
							{
								$htmlout .= "\n$st<a href=\"$fileimage\" onclick=\"window.open(this.href);return false;\" ><img width=\"" . $field['thumbsize'] . "\"  alt=\"\" ";
								$htmlout .= tooltip(fn_i18n("_CLICKONTHEPHOTO"));
								$htmlout .= " border=\"0\" src=\"$fileimage\" /></a>$et<br />";
							}
							else
							{
								if ( $fileimage != "" && !file_exists($fileimage) )
								{
									$htmlout .= "<br />" . basename($fileimage) . "<br />";
								}
							}
						}
						break;
					/*
					  case "_file" :
					  {
					  $fileimage = isset($row['unirecid']) ? "$path/$databasename/$tablename/" . $row['unirecid'] . "/" . $field['name'] . "/" . $row[$field['name']] : "";
					  $fileimage2 = isset($row['unirecid']) ? "" . $row['unirecid'] . "/" . $field['name'] . "/" . $row[$field['name']] : "";
					  $htmlout .= " \n$st$title ";
					  $htmlout .= "\n<a title=\"Download $value\" href=\"?mod={$_FN['vmod']}&amp;mode=go&amp;downloadfile=$fileimage2\"  >$value</a>";
					  $fsize = 0;
					  if ( file_exists($fileimage) )
					  $fsize = filesize($fileimage);
					  $suff = "bytes";
					  if ( $fsize > 1024 )
					  {
					  $fsize = round($fsize / 1024,2);
					  $suff = "Kb";
					  }
					  if ( $fsize > 1024 )
					  {
					  $fsize = round($fsize / 1024,2);
					  $suff = "Mb";
					  }
					  $stat = new XMLTable($databasename,$tablename . "_download_stat",$_FN['datadir']);
					  $val = $stat->GetRecordByPrimaryKey($fileimage2);
					  //dprint_r($stat);
					  $count = isset($val['numdownload']) ? $val['numdownload'] : 0;
					  $st = " | $count Download";
					  $htmlout .= "&nbsp;($fsize $suff$st)$et";
					  }
					  break;
					 */
					case "text" :
						$htmlout .= " \n$st$title " . str_replace("\n", "<br />", htmlspecialchars($value)) . "$et";
						break;
					case "html" :
						$htmlout .= " \n$st$title " . $value . "$et";
						break;
					case "separator" :
						$htmlout .= "";
						break;
					case "url" :
						$vaw = $value;
						if ( !preg_match('/^http\\:\\/\\//si', $vaw) )
							$vaw = "http://$value";
						$htmlout .= "\n$st$title <a onclick=\"window.open(this.href);return false;\" href=\"$vaw\">$value</a>$et";
						break;
					case "email" :
						$vaw = "mailto:$value";
						$htmlout .= "\n$st$title <a href=\"$vaw\">$value</a>$et";
						break;
					default :
						if ( function_exists("xmldb_view" . $field['frm_type']) )
						{
							$funct = "xmldb_view" . $field['frm_type'];
							$htmlout .= $funct($row, $path, $databasename, $tablename, $field, $title, $value, $st, $et);
						}
						else
						{
							if ( preg_match("/^html/is", $field['frm_type']) )
							{
								$htmlout .= " \n$st$title " . $value . "$et";
							}
							else
							{
								$htmlout .= " \n$st$title " . str_replace("\n", "<br />", htmlspecialchars($value)) . "$et";
							}
						}
						break;
				}
				$htmlout .= "</span></span>";
			}
		if ( isset($field['view_endgroup']) )
		{
			$htmlout .= "</div>";
		}
	}
	//----innertables---->
	/*
	  $oldvalues = $row;
	  if ( $Table->innertables )
	  {
	  foreach ( $Table->innertables as $k=>$v )
	  {
	  $params['echo'] = false;
	  $params['path'] = $Table->path;
	  $params['enableedit'] = true;
	  $params['enablenew'] = false;
	  $params['enabledelete'] = false;
	  $params['enableview'] = true;
	  $t = explode(",",$v["linkfield"]);
	  if ( isset($t[1]) && $t[1] != "" && isset($oldvalues[$t[0]]) )
	  $params['restr'] = array($t[1]=>$oldvalues[$t[0]]);
	  else
	  $params['restr'] = array($v["linkfield"]=>$oldvalues[$Table->xmltable->primarykey]);
	  if ( isset($v["tablename"]) && isset($oldvalues[$Table->xmltable->primarykey]) )
	  {
	  $tmptable = xmldb_form($databasename,$v["tablename"],$path,$lang,$languages,$params);
	  //dprint_r( $params);
	  if ( $v['view'] == "list" )
	  {
	  $params['fields'] = $v["view_fields"];
	  $params['enableview'] = false;
	  $params['enableedit'] = false;
	  $htmlout .= XMLDB_editor($v["tablename"],$Table->databasename,$params);
	  }
	  else
	  {
	  $allview = $tmptable->xmltable->getRecords($params['restr']);
	  if ( is_array($allview) )
	  foreach ( $allview as $view )
	  {
	  $htmlout .= xmldb_view($view[$tmptable->xmltable->primarykey],$v["tablename"],$databasename,$path,$lang,$languages,$params);
	  }
	  }
	  }
	  }
	  }
	 */
	//----innertables----<
	return $htmlout;
}
/**
 * 
 * @param string $field
 * @param string $title
 * @param string $value
 * @param string $st
 * @param string $et
 */
function xmldb_viewfile($row, $path, $databasename, $tablename, $field, $title, $value, $st, $et)
{
	global $_FN;
	$table = xmldb_table($databasename, $tablename);
	$htmlout = "";
	$tablepath = $table->FindFolderTable($row);

	$fileimage = isset($row[$table->primarykey]) ? "$path/$databasename/$tablepath/" . $row[$table->primarykey] . "/" . $field['name'] . "/" . $row[$field['name']] : "";
	$fileimage2 = isset($row[$table->primarykey]) ? "" . $row[$table->primarykey] . "/" . $field['name'] . "/" . $row[$field['name']] : "";
	$htmlout .= " \n$st$title ";
	$link = getparam("QUERY_STRING", PAR_SERVER, SAN_FLAT);
	//dprint_r($_SERVER['QUERY_STRING']);
	$htmlout .= "\n<a title=\"Download $value\" href=\"?$link&xmldb_ddfile_{$field['name']}={$row[$field['name']]}\"  >$value</a>";
	$downloadfile = strippostpslashes(getparam("xmldb_ddfile_{$field['name']}", PAR_GET, SAN_FLAT));
	if ( $downloadfile != "" && $downloadfile == $row[$field['name']] )
	{
		$downloadfile = $row[$table->primarykey] . "/{$field['name']}/$downloadfile";
		xmldb_go_download($downloadfile, $databasename, $tablename, $path,$tablepath);
	}
	$fsize = 0;
	if ( file_exists($fileimage) )
		$fsize = filesize($fileimage);
	$suff = "bytes";
	if ( $fsize > 1024 )
	{
		$fsize = round($fsize / 1024, 2);
		$suff = "Kb";
	}
	if ( $fsize > 1024 )
	{
		$fsize = round($fsize / 1024, 2);
		$suff = "Mb";
	}
	$stat = new XMLTable($databasename, $tablename . "_download_stat", $_FN['datadir']);
	$val = $stat->GetRecordByPrimaryKey($fileimage2);
	//dprint_r($stat);
	$count = isset($val['numdownload']) ? $val['numdownload'] : 0;
	$st = " | $count Download";
	$htmlout .= "&nbsp;($fsize $suff$st)$et";
	return $htmlout;
}
/**
 *
 * @global <type> $databasename
 * @global <type> $tablename
 * @global <type> $pathdatabase
 * @param <type> $file
 * @param <type> $databasename
 * @param <type> $tablename
 * @param <type> $pathdatabase 
 */
function xmldb_go_download($file, $databasename, $tablename, $pathdatabase,$tablepath)
{

	// evita di accedere a directory esterne
	if ( stristr($file, "..") )
		die(fn_i18n("_NONPUOI"));
	// se il file non esiste lo crea
	if ( !file_exists("$pathdatabase/$databasename/$tablename" . "_download_stat.php") )
	{
		//echo "<br>creazione statistiche $tablename";
		$sfields = array();
		$sfields[1]['name'] = "filename";
		$sfields[1]['primarykey'] = "1";
		$sfields[2]['name'] = "numdownload";
		$sfields[2]['defaultvalue'] = "0";
		echo createxmltable($databasename, $tablename . "_download_stat", $sfields, $pathdatabase);
	}
	$stat = new XMLTable($databasename, $tablename . "_download_stat", $pathdatabase);
	$oldval = $stat->GetRecordByPrimaryKey($file);


	$r['filename'] = $file;
	if ( $oldval == null )
	{
		$r['numdownload'] = 1;
		$stat->InsertRecord($r);
	}
	else
	{
		//incrementa download
		$r['numdownload'] = $oldval['numdownload'] + 1;
		$stat->UpdateRecord($r);
	}

	$file = "$pathdatabase/$databasename/$tablepath/$file";

	//First, see if the file exists
	if ( !is_file($file) )
	{
		die("<b>$file 404 File not found!</b>");
	}

	//Gather relevent info about file
	$len = filesize($file);
	$filename = basename($file);
	$file_extension = strtolower(substr(strrchr($filename, "."), 1));
	//This will set the Content-Type to the appropriate setting for the file
	switch ( $file_extension )
	{
		case "pdf" :
			$ctype = "application/pdf";
			break;
		case "exe" :
			$ctype = "application/octet-stream";
			break;
		case "zip" :
			$ctype = "application/zip";
			break;
		case "doc" :
			$ctype = "application/msword";
			break;
		case "xls" :
			$ctype = "application/vnd.ms-excel";
			break;
		case "ppt" :
			$ctype = "application/vnd.ms-powerpoint";
			break;
		case "gif" :
			$ctype = "image/gif";
			break;
		case "png" :
			$ctype = "image/png";
			break;
		case "jpeg" :
		case "jpg" :
			$ctype = "image/jpg";
			break;
		case "mp3" :
			$ctype = "audio/mpeg";
			break;
		case "wav" :
			$ctype = "audio/x-wav";
			break;
		case "mpeg" :
		case "mpg" :
		case "mpe" :
			$ctype = "video/mpeg";
			break;
		case "mov" :
			$ctype = "video/quicktime";
			break;
		case "avi" :
			$ctype = "video/x-msvideo";
			break;

		//The following are for extensions that shouldn't be downloaded (sensitive stuff, like php files)
		case "php" :
		case "htm" :
		case "html" :
		case "txt" :
			$ctype = "application/force-download";
			break;

		default :
			$ctype = "application/force-download";
	}
	ob_end_clean();
	//Begin writing headers
	header("Pragma: public");
	header("Expires: 0");
	header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
	header("Cache-Control: public");
	header("Content-Description: File Transfer");
	//Use the switch-generated Content-Type
	header("Content-Type: $ctype");
	//Force the download
	$header = "Content-Disposition: attachment; filename=" . $filename . ";";
	header($header);
	header("Content-Transfer-Encoding: binary");
	header("Content-Length: " . $len);
	@readfile($file);
	exit ();
	die();
}
/**
 * 
 * @param string $field
 * @param string $title
 * @param string $value
 * @param string $st
 * @param string $et
 */
function xmldb_viewlink($row, $path, $databasename, $tablename, $field, $title, $value, $st, $et)
{
	$htmlout = "$st";
	if ( $value != "" )
	{
		if ( !preg_match("/^http:\\/\\//si", $value) )
		{
			$value = htmlspecialchars($value);
			$value = "http://$value";
		}
		$htmlout .= "<a onclick=\"window.open(this.href);return false;\" href=\"$value\">$value</a>";
	}
	$htmlout .= "$et";
	return $htmlout;
}
/**
 * 
 * @param string $field
 * @param string $title
 * @param string $value
 * @param string $st
 * @param string $et
 */
function xmldb_viewswf($row, $path, $databasename, $tablename, $field, $title, $value, $st, $et)
{
	$htmlout = "$st";
	if ( preg_match('/\.swf/is', $row[$field['name']]) )
	{
		$fileflash = isset($row['unirecid']) ? "$path/$databasename/$tablename/" . $row['unirecid'] . "/" . $field['name'] . "/" . $row[$field['name']] : "";
		$htmlout .= "\n$st$title ";
		$htmlout .= "\n<object width=\"550\" height=\"400\">
<param name=\"movie\" value=\"$fileflash\">
<embed src=\"$fileflash\" width=\"550\" height=\"400\">
</embed>
</object>$et";
	}
	else
	{
		$htmlout = "$st$et";
	}
	return $htmlout;
}
/**
 * 
 * @param string $field
 * @param string $title
 * @param string $value
 * @param string $st
 * @param string $et
 */
function xmldb_viewyoutubelink($row, $path, $databasename, $tablename, $field, $title, $value, $st, $et)
{
	$htmlout = "$st";
	$html = "";
	$codes = explode(",", $value);
	foreach ( $codes as $value )
	{
		$c = "v";
		$code = explode("/v/", $value);
		if ( !isset($code[1]) )
			$code = explode("?v=", $value);
		if ( !isset($code[1]) )
		{
			$code = explode("/p/", $value);
			$c = "p";
		}
		if ( !isset($code[1]) )
		{
			$code = explode("?p=", $value);
			$c = "p";
		}
		if ( isset($code[1]) )
		{
			$h = 344;
			$w = 425;
			$code = $code[1];
			if ( false !== strstr($code, "&") )
				$code = substr($code, 0, strpos($code, "&"));
			if ( false !== strstr($code, "?") )
				$code = substr($code, 0, strpos($code, "?"));
			if ( $code != "" )
			{
				$code = "http://www.youtube.com/$c/$code&amp;autoplay=0&amp;rel=0";
				$html .= "<div style=\"height:$h;width:$w;overflow:auto\">";
				//$html .= "<center>";
				$html .= "<object width=\"$w\" height=\"$h\">
					<param name=\"movie\" value=\"$code\"></param>
					<param name=\"enablejsapi\" value=\"1\"></param>
					<param name=\"allowFullScreen\" value=\"true\"></param>
					<embed src=\"$code\" type=\"application/x-shockwave-flash\" enablejsapi=\"1\" allowfullscreen=\"true\" width=\"$w\" height=\"$h\"></embed></object>";
				//$html .= "</center>";
				$html .= "</div>";
			}
			else
			{
				$html .= htmlentities($value);
			}
		}
	}
	$htmlout .= " \n$st$title " . $html . "$et";
	return $htmlout;
}
?>