<?php
/**
 * index.php Created on 14/dic/07
 *
 * @package Flatnux
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 */
global $_FN;
include_once "include/flatnux.php";
if ( $_FN['mod'] == "" && $_FN['home_section'] != "" && !isset($_GET['opindex']) )
{
	$querystring = getparam("QUERY_STRING", PAR_SERVER, SAN_FLAT);
	$idmod = get_section_id($_FN['home_section']);
	$goto = fn_rewritelink("index.php?mod={$idmod}");
	header("location:{$_FN['siteurl']}$goto");
}
if ( !empty($_SERVER['SERVER_NAME']) && false === strpos($_FN['siteurl'], "/" . $_SERVER['SERVER_NAME']) )
{
	$querystring = getparam("QUERY_STRING", PAR_SERVER, SAN_FLAT);
	header("location:{$_FN['siteurl']}$querystring");
}
require_once "include/head.php";
//script automatici ----->
if ( file_exists("include/autoexec.d/") && false != ($handle = opendir('include/autoexec.d/')) )
{
	$filestorun = array();
	while ( false !== ($file = readdir($handle)) )
		if ( get_file_extension($file) == "php" && !preg_match("/^none_/si", $file) )
			$filestorun[] = $file;
	closedir($handle);
	fn_natsort($filestorun);
	foreach ( $filestorun as $runfile )
	{
		include ("include/autoexec.d/$runfile");
	}
}
//script automatici -----<	
function getflopt()
{
	global $_FN;
	$opindex = getparam("opindex", PAR_GET, SAN_FLAT);
	if ( $_FN['mod'] == "modcont" )
		$opindex = "modcont";

	if ( $opindex )
	{
		$filetomodify = getparam("file", PAR_GET, SAN_FLAT);
		if ( $filetomodify != "" && can_modify_file($_FN['user'], $filetomodify) )
		{
			if ( fn_erg('config.php$', $filetomodify) )
				fn_editconffile($filetomodify);
			else
				edit_content($filetomodify);
		}
	}
	else
	{
		$sectionborders = true;
		if ( $_FN['show_welcome_message'] !== 0 && $_FN['vmod'] == $_FN['home_section'] )
		{
			if ( !isset($_GET['op']) && !isset($_GET['opindex']) )
			{
				$sectionborders = false; //non visualizzo footer sezione e bordi
				showmotd();
			}
		}
		if ( $_FN['vmod'] != "" ) //se esiste la sezione di default
		{
			if ( ($_FN['show_welcome_message'] === 0 ) )
			{
				$sectionborders = true;
			}
			view_section($_FN['vmod'], $sectionborders);
		}
		if ( $_FN ['enable_online_administration'] && function_exists("ShowAdminOptions") )
		{
			ShowAdminOptions();
		}
	}
}
include "./themes/" . $_FN['theme'] . "/structure.php";
//--- valuto se chiudere i tag ---->
$structurestring = ob_get_contents();
if ( strrpos($structurestring, "</body>") === false )
	echo "</body>";
if ( strrpos($structurestring, "</html>") === false )
	echo "</html>";
//--- valuto se chiudere i tag ----<


$str = ob_get_contents();
ob_end_clean();
if ( $_FN['close_tag'] == "" )
{
	$str = str_replace("/>", ">", $str);
}
if ( $_FN['enable_compress_gzip'] )
{
	header("Content-Encoding: gzip");
	die(gzencode($str));
}
else
	die($str);
?>