<?php
/**
 * print.php
 *
 * @package Flatnux
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 */
global $_FN;
include "./include/flatnux.php";
//script automatici ----->
$handle = opendir('include/autoexec.d/');
$filestorun = array();
while (false !== ($file = readdir($handle)))
{
	if ( get_file_extension($file) == "php" &&  !preg_match("/^none_/si",$file) )
		$filestorun[] = $file;
}
closedir($handle);
fn_natsort($filestorun);
foreach ( $filestorun as $runfile )
{
	include ("include/autoexec.d/$runfile");
}
//script automatici -----<	
//-- comanda il print.php sotto la sezione (se esiste)
if ( file_exists("sections/" . $_FN['vmod'] . "/print.php") )
{
	include ("sections/" . $_FN['vmod'] . "/print.php");
	die();
}
?>
<html>
<head>
<title><?php
echo $_FN['sitename']?></title>
</head>
<body>
<?php
if ( isset($_GET['file']) )
	$file = str_replace(chr(00),"",$_GET['file']);
else
	$file = "";
	// evita di risalire le directory
if ( strstr($_FN['vmod'],"..") )
	die(fn_i18n("_NONPUOI"));
if ( strstr($file,"..") )
	die(fn_i18n("_NONPUOI"));
if ( $file == "" )
{
	if (  !file_exists("sections/{$_FN['vmod']}/section.php") &&  !file_exists("sections/{$_FN['vmod']}/section.{$_FN['lang']}.html") )
		die(fn_i18n("_NONPUOI"));
}
else
{
	if (  !file_exists('sections/' . $_FN['vmod'] . '/' . $file) )
		die(fn_i18n("_NONPUOI"));
}
$secttitle = getlang("sections/{$_FN['vmod']}/lang.xml");
echo "<div align=\"center\"><h3>$secttitle</h3><br />
		<table width=\"800\"><tr><td><font size=\"3\">";
view_section($_FN['vmod'],false);
echo "</font></td></tr></table>";
echo "<br /><br /><small>" . fn_i18n("_ARTTR") . " <b>{$_FN['sitename']}</b> -
	<a href=\"{$_FN['siteurl']}\">{$_FN['siteurl']}</a><br />" . fn_i18n("_URLREF") . "
	<a href=\"{$_FN['siteurl']}/index.php?mod={$_FN['vmod']}\">" . "{$_FN['siteurl']}/index.php?mod={$_FN['vmod']}" . "</a></small></div>";
?>
<script type="text/javascript" language="javascript1.2">
//<!--
// Do print the page
if (typeof(window.print) != 'undefined')
{
    window.print();
}
//-->
</script>
</body>
</html>