<?php
/**
 * controlcenter_module.php created on 23/dic/2008
 *
 * 
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 */
ini_set("max_execution_time", "30000");
$keepoldid = true;
$imgnew = "<img style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/add.png") . "\" alt=\"\" />&nbsp;";
$imgedit = "<img style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/modify.png") . "\" alt=\"\" />";
$imgeview = "<img style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/read.png") . "\" alt=\"\" />";

$op = getparam("op", PAR_GET, SAN_FLAT);
$opt = getparam("opt", PAR_GET, SAN_FLAT);

$section = fn_erg_replace('^sections_', '', $opt);
require_once "sections/$section/functions.php";
include "sections/$section/config.php";
$_FN["news_tablename"] = $tablename;
$_FN["news_enablecomments"] = $enablecomments;
$_FN["news_guestnews"] = $guestnews;
$_FN["news_signews"] = $signews;
$_FN["news_generate_googlesitemap"] = $generate_googlesitemap;
$_FN["news_guestcomment"] = $guestcomment;
$_FN['editor_folder'] = "{$_FN['datadir']}/news";
$_FN['force_htmleditor'] = $htmleditornews;

if ( $op == "import" )
{
	import_news($keepoldid);
}
elseif ( $op == "editarguments" )
{
	arguments_admin();
}
else
{
	news_admin();
	if ( !isset($_GET['op___xdb_news']) && !isset($_GET['op___xdb_news_arguments']) && file_exists("{$_FN['datadir']}/news"))
		echo "<br /><br /><hr /><br /><img src=\"images/icons/tipp.png\" />&nbsp;<a href=\"javascript:check('?mod={$_FN['mod']}&op=import&opt=$opt')\">Import old news from {$_FN['datadir']}/news</a>";
}
/**
 *
 * @global <type> $_FN
 * @param bool $keepoldid
 */
function import_news($keepoldid)
{
	global $_FN;
	$tablenews = xmldb_table("fndatabase", "news");
	$tablecomments = xmldb_table("fndatabase", "news_comments");
	$tablearguments = xmldb_table("fndatabase", "news_arguments");

	if ( isset($_GET['truncate']) )
	{
		$tablenews->Truncate();
		$tablearguments->Truncate();
		$tablecomments->Truncate();
	}

	//old news
	$alloldnews = $tablenews->GetRecords();
	$allnewsimported = array();
	if ( is_array($alloldnews) )
		foreach ( $alloldnews as $item )
		{
			$allnewsimported[$item['idimport']] = $item;
		}
	//old comments
	$allcommentsimported = array();
	$alloldcomments = $tablecomments->GetRecords();
	if ( is_array($alloldcomments) )
		foreach ( $alloldcomments as $item )
		{
			$allcommentsimported[$item['idimport']] = $item;
		}
	//old arguments
	$allargumentsimported = array();
	$alloldarguments = $tablearguments->GetRecords();

	if ( is_array($alloldarguments) )
	{
		foreach ( $alloldarguments as $item )
		{
			$allargumentsimported[$item['idimport']] = $item;
		}
	}

///*******************************************************
	foreach ( $_FN['listlanguages'] as $curlang )
	{
		$op = getparam("op", PAR_GET, SAN_FLAT);
		$newsdir = "news";
		$modlist = array();
		$modlocked = array();
		$handle = opendir("{$_FN['datadir']}/$newsdir/" . $curlang);
		while ( false !== ($file = readdir($handle)) )
		{
			if ( preg_match('/^[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9].xml$/si', $file) )
			{
				$modlist[] = $file;
			}
		}
		closedir($handle);
		foreach ( $modlist as $mod )
		{
			$modlocked[] = $mod;
		}
		$i = 0;
		sort($modlist);
		foreach ( $modlocked as $mod )
		{
			$newvalues = array();

			$string = get_file("{$_FN['datadir']}/$newsdir/$curlang/$mod");
			$oldid = "$curlang/$mod";
			$oldid = str_replace(".xml", "", $oldid);
			$oldid = str_replace(".php", "", $oldid);
			$by = "";
			$by = get_xml_single_element("fn:by", $string);
			$locked = get_xml_single_element("fn:locked", $string);
			$titlenews = get_xml_single_element("fn:title", $string);
			$header = get_xml_single_element("fn:header", $string);
			$avatar = get_xml_single_element("fn:avatar", $string);
			$numread = get_xml_single_element("fn:reads", $string);

			if ( $avatar == "notizie.png" )
				$avatar = "news.png";

			//arguments----------------------------------------------------------->
			if ( $avatar != "" )
			{
				$avatars[$avatar]['img'] = $avatar;
				if ( !isset($avatars[$avatar]['id']) )
				{
					$newvalues = array();
					$_FILES = array();
					if ( file_exists("{$_FN['datadir']}/news/arguments/$avatar") )
					{
						$newvalues['icon'] = $avatar;
						$_FILES['icon']['name'] = $avatar;
						$_FILES['icon']['tmp_name'] = "{$_FN['datadir']}/news/arguments/$avatar";
					}
					$titavatar = fn_erg_replace("\.png$", "", $avatar);
					$title = getLang("{$_FN['datadir']}/news/arguments/$avatar.xml", $titavatar, $_FN['lang_default']);
					$newvalues['title'] = $title;
					foreach ( $_FN['listlanguages'] as $l )
					{
						$newvalues['title_' . $l] = getLang("{$_FN['datadir']}/news/arguments/$avatar.xml", $titavatar, $l);
					}

					$newvalues['idimport'] = "oldnews_" . md5(implode(",", $newvalues));

					$oldvalues = isset($allargumentsimported[$newvalues['idimport']]) ? $allargumentsimported[$newvalues['idimport']] : false;
					if ( isset($oldvalues['idimport']) )
					{
						$newvalues['unirecid'] = $oldvalues['unirecid'];
						$newvalues = $tablearguments->UpdateRecord($newvalues);
						$nv = $newvalues;
					}
					else
					{
						$nv = $tablearguments->InsertRecord($newvalues);
					}
					$avatars[$avatar]['id'] = $nv['unirecid'];
					$avatars[$avatar]['values'] = $nv;
				}
			}
			//dprint_r($_FN);
			//arguments-----------------------------------------------------------<
			//news---------------------------------------------------------------->
			$newvalues = array();
			$body = get_xml_single_element("fn:body", $string);
			$datetext = str_replace(".xml", "", $mod);
			$datetext = str_replace(".php", "", $datetext);
			if ( $curlang != $_FN['lang_default'] )
			{
				$newvalues['title'] = "";
				$newvalues['summary'] = "";
				$newvalues['body'] = "";
				$newvalues['title_' . $curlang] = $titlenews;
				$newvalues['summary_' . $curlang] = $header;
				$newvalues['body_' . $curlang] = $body;
				//dprint_r($newvalues);
			}
			else
			{
				$newvalues['title'] = $titlenews;
				$newvalues['summary'] = $header;
				$newvalues['body'] = $body;
			}
			$newvalues['txtid'] = gen_txt_id_import($newvalues['title'], "news");

			$newvalues['date'] = date("Y-m-d H:i:s", $datetext);
			$newvalues['locktop'] = $locked;
			$newvalues['status'] = "1";
			$newvalues['username'] = $by;
			if ( isset($avatars[$avatar]['id']) )
			{
				$newvalues['argument'] = $avatars[$avatar]['id'];
			}
			//$newvalues['idimport'] = "oldnews_" . $datetext;
			$newvalues['idimport'] = "oldnews_" . $oldid;



			$oldnews = isset($allnewsimported[$newvalues['idimport']]) ? $allnewsimported[$newvalues['idimport']] : false;
			if ( isset($oldnews['idimport']) )
			{
				$newvalues['unirecid'] = $oldnews['unirecid'];
				$newvalues = $tablenews->UpdateRecord($newvalues);
				$mode = "update";
				force_news_stat("news", $newvalues, "unirecid", $numread);
			}
			else
			{
				if ( $keepoldid )
					$newvalues['unirecid'] = $oldid;
				$newvalues = $tablenews->InsertRecord($newvalues);
				if ( !is_array($newvalues) )
				{
					dprint_r($newvalues);
					die();
				}

				$mode = "insert";
				force_news_stat("news", $newvalues, "unirecid", $numread);
			}
			dprint_r("<b>$mode " . $newvalues['title'] . " $oldid</b>");
			//news----------------------------------------------------------------<
			//news comments------------------------------------------------------->
			if ( isset($newvalues['unirecid']) )
			{
				//dprint_xml($string);
				$comments = get_xml_element("fn:comments", $string);
				$comments = get_xml_array("fn:comment", $comments);
				foreach ( $comments as $comment )
				{
					$commentvalues = array();
					$date_comment = get_xml_element("fn:date", $comment);
					if ( $date_comment != "" )
						$date_comment = date("Y-m-d H:i:s", $date_comment);
					else
						$date_comment = "";
					$user = get_xml_element("fn:by", $comment);
					$comment = get_xml_element("fn:post", $comment);
					$commentvalues['unirecidrecord'] = $newvalues['unirecid'];
					$commentvalues['username'] = $user;
					$commentvalues['comment'] = $comment;
					$commentvalues['insert'] = $date_comment;
					$commentvalues['idimport'] = "oldnews_" . md5(implode(",", $commentvalues));
					if ( $commentvalues['comment'] != "" )
					{
						$oldvalues = isset($allcommentsimported[$commentvalues['idimport']]) ? $allcommentsimported[$commentvalues['idimport']] : false;
						if ( isset($oldvalues['idimport']) )
						{
							$commentvalues['unirecid'] = $oldvalues['unirecid'];
							$commentvalues = $tablecomments->UpdateRecord($commentvalues);
							$mode = "update";
						}
						else
						{
							$commentvalues = $tablecomments->InsertRecord($commentvalues);
							$mode = "insert";
						}
						//dprint_r($commentvalues);
						dprint_r("----$mode comment {$commentvalues['unirecidrecord']} by {$commentvalues['username']}");
					}
				}
			}
			//news comments-------------------------------------------------------<
		}
	}
///*******************************************************
	//dprint_r($avatars);
}
function gen_txt_id_import($text, $tablename)
{
	global $_FN;
	static $textid = "";
	static $txtids = array();
	//recupero i vecchi
	if ( $textid == "" )
	{
		$table = xmldb_form("fndatabase", $tablename, $_FN['datadir'], $_FN['lang'], $_FN['languages']);
		$all = $table->xmltable->GetRecords();
		if ( is_array($all) )
			foreach ( $all as $item )
			{
				$txtids[] = $item['txtid'];
			}
	}
	$acc = "";
	$text = strtolower(str_replace(" ", "_", $text));
	$text = preg_replace("//s", "a", $text);
	$text = preg_replace("//s", "a", $text);
	$text = preg_replace("//s", "e", $text);
	$text = preg_replace("//s", "e", $text);
	$text = preg_replace("//s", "i", $text);
	$text = preg_replace("//s", "i", $text);
	$text = preg_replace("//s", "o", $text);
	$text = preg_replace("//s", "o", $text);
	$text = preg_replace("//s", "u", $text);
	$text = preg_replace("//s", "u", $text);
	$text = preg_replace("/[^A-Z^a-z_0-9]/s", "_", $text);
	$text = str_replace("-", "_", $text);
	$text = str_replace(".", "_", $text);
	if ( $text == "" )
		$text = "_";
	do
	{
		$textid = $text . $acc;
		$acc = intval($acc) + 1;
	} while ( in_array($textid, $txtids) );
	$txtids[] = $textid;
	return $textid;
}
/**
 *
 * @param string $tablename
 * @param array $row
 * @param string $pkf
 */
function force_news_stat($tablename, $row, $pkf="unirecid", $num=0)
{
	global $_FN;
	//-------statistiche---------------------->>
	if ( !file_exists("{$_FN['datadir']}/fndatabase/$tablename" . "_stat") )
	{
		$sfields = array();
		$sfields[0]['name'] = "unirecid";
		$sfields[0]['primarykey'] = "1";
		$sfields[1]['name'] = "view";
		echo createxmltable("fndatabase", $tablename . "_stat", $sfields, $_FN['datadir']);
	}
	$tbtmp = xmldb_table("fndatabase", $tablename . "_stat", $_FN['datadir']);
	$tmprow['unirecid'] = $row[$pkf];
	if ( ($oldview = $tbtmp->GetRecordByPrimaryKey($row[$pkf])) == false )
	{
		$tmprow['view'] = $num;
		$rowtmp = $tbtmp->InsertRecord($tmprow);
	}
	else
	{
		$oldview['view'] = $num;
		$rowtmp = $tbtmp->UpdateRecord($oldview); //aggiunge vista
	}
	//-------statistiche----------------------<<
}
?>
