<?php
/**
 * @package flatnux_section_news
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 * 
 */
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']), strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}

//TODO: googlemap rss fuso orario
require_once ("sections/{$_FN['vmod']}/functions.php");
global $_FN, $guestnews, $signews;
$op = getparam("op", PAR_GET, SAN_FLAT);
$opmod = getparam("opmod", PAR_GET, SAN_FLAT);
if ( $op=="" && $opmod != "" )
	$op = $opmod;
$config = getparam("config", PAR_GET, SAN_FLAT);
$id = getparam("id", PAR_GET, SAN_FLAT);
//dprint_r($_GET);
$tablename = "";
$enablecomments = "0";
$guestnews = 0;
$signews = 0;
$generate_googlesitemap = 0;
$guestcomment = 0;
include ("sections/{$_FN['vmod']}/config.php");
$_FN["news_tablename"] = $tablename;
$_FN["news_enablecomments"] = $enablecomments;
$_FN["news_guestnews"] = $guestnews;
$_FN["news_signews"] = $signews;
$_FN["news_generate_googlesitemap"] = $generate_googlesitemap;
$_FN["news_guestcomment"] = $guestcomment;
$_FN['editor_folder'] = "{$_FN['datadir']}/news";
$_FN['force_htmleditor'] = $htmleditornews;
if ( $_FN["news_tablename"] == "" )
{
	$_FN["news_tablename"] = $_FN['idmod'];
}

//crea le tabelle --->
news_init_tables($_FN["news_tablename"]);
//crea le tabelle ---<
$imgedit = "<img style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/modify.png") . "\" alt=\"\" />";
$imgedel = "<img style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/delete.png") . "\" alt=\"\" />";
$imgeview = "<img style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/news.png") . "\" alt=\"\" />";
$imgnew = "<img style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/add.png") . "\" alt=\"\" />&nbsp;";
$imgback = "<img style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/icons/back.png") . "\" alt=\"\" />&nbsp;";
if ( $generate_googlesitemap && is_writable(".") && is_writable(".") && !file_exists("sitemap_news.xml") )
{
	generate_GOOGLESITEMAP();
}
switch ( $op )
{
	case "read" :
	case "view" :
	case "del_news_comment" :
	case "comment" :
		del_news_comment($id, $_FN["news_tablename"]);
		$Table = xmldb_form("fndatabase", $tablename, $_FN['datadir'], $_FN['lang'], $_FN['languages']);
		$itemnews = $Table->xmltable->GetRecordByPrimarykey($id);
		$news_contents = get_news_contents($itemnews);
		if ( isset($news_contents['status']) && $news_contents['status'] == 1 )
		{
			news__print_news($news_contents);
		}
		echo "<br /><br />$imgback<a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}") . "\">" . fn_i18n("Back_to_the_news") . "</a>";
		break;
	case "edit" :
		if ( is_news_administrator ( ) )
		{
			news_admin();
		}
		break;
	case "editarguments":
		if ( is_news_administrator ( ) )
		{
			arguments_admin();
		}
		break;
	case "submitnews";
		if ( $signews )
		{
			if ( $_FN['user'] != "" || $guestnews )
			{
				submit_news($tablename);
			}
			else
			{
				echo fn_i18n("_DEVIREG") . " " . $_FN['sitename'] . " " . fn_i18n("_DEVIREG3");
			}
		}
		break;
	default :
		//---if op is txtid --->
		if ( $op != "" )
		{
			$Table = xmldb_form("fndatabase", $tablename, $_FN['datadir'], $_FN['lang'], $_FN['languages']);
			$itemnews = $Table->xmltable->GetRecord(array("txtid" => $op));
			if ( isset($itemnews['unirecid']) )
			{
				$unirecid = $itemnews['unirecid'];
				del_news_comment($unirecid, $tablename);
				$news_contents = get_news_contents($itemnews, $tablename);
				if ( isset($news_contents['status']) && $news_contents['status'] == 1 )
				{
					update_news_stat($tablename, $itemnews, "unirecid");
					news__print_news($news_contents, $tablename);
				}
			}
			echo "<br /><br />$imgback<a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}") . "\">" . fn_i18n("Back_to_the_news") . "</a>";
		}
		//---if op is txtid ---<
		else
		{
			print_list_news();
			if ( is_news_administrator( ) )
			{
				echo "<br />$imgeview&nbsp;";
				echo "<a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=edit&amp;signews=1") . "\">" . fn_i18n("_SEGNNOTIZIE") . "</a>";
				$signews = count_sig_news($tablename);
				if ( $signews > 0 )
					echo "&nbsp;($signews)";
				echo "<br />$imgnew&nbsp;<a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=edit&amp;op___xdb_news=insnew") . "\">" . fn_i18n("_ADDNEWS") . "</a>";
			}
			elseif ( $signews )
			{
				if ( $guestnews || $_FN['user'] != "" )
					echo "$imgnew<a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=submitnews") . "\">" . fn_i18n("Submit_news") . "</a>";
			}
		}
		break;
}
?>