<?php
/**
 * @package flatnux_section_download
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 * 
 */
global $_FN;
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}
if (  !file_exists($_FN['datadir'] . "/Download") )
	mkdir($_FN['datadir'] . "/Download");
global $show_stats;
include ("sections/{$_FN['vmod']}/config.php");
$dirname = strippostpslashes(getparam("dirname",PAR_POST,SAN_FLAT));
$downloadfile = strippostpslashes(getparam("downloadfile",PAR_GET,SAN_FLAT));
$deldir = strippostpslashes(getparam("deldir",PAR_GET,SAN_FLAT));
$filename = strippostpslashes(getparam("filename",PAR_POST,SAN_FLAT));
$title = strippostpslashes(getparam("title",PAR_POST,SAN_FLAT));
$location = strippostpslashes(getparam("location",PAR_POST,SAN_FLAT));
if ( strstr($dirname,"..") )
	die(_NONPUOI);
if ( strstr($downloadfile,"..") )
	die(_NONPUOI);
	// opzioni di amministrazione ------------------>
if ( is_admin() )
{
	if ( $deldir != "" )
	{
		$filename = strippostpslashes(getparam("filename",PAR_GET,SAN_FLAT));
		$handle = opendir($filename);
		//die ($filename);
		while (false !== ($file = readdir($handle)))
		{
			if ( preg_match("/^description./si",$file) )
			{
				unlink($filename . "/$file"); //elimino le descrizioni
			}
		}
		rmdir($filename);
	}
	if ( isset($_POST['newdir']) )
	{
		mkdir($_FN['datadir'] . "/Download/" . $dirname);
		$filetoopen = ($_FN['datadir'] . "/Download/" . $dirname) . "/description.{$_FN['lang']}.html";
		$hfile = fopen($filetoopen,"w");
		fwrite($hfile,$title);
	}
	if ( isset($_POST['changetitle']) )
	{
		$filetoopen = $filename;
		$hfile = fopen($filetoopen,"w");
		fwrite($hfile,$title);
	}
	if ( $_FN['fneditmode'] != 0 )
	{
		?>
<span class='flatnukeadmin'><b><?php
		echo _FOLDER_CREATE?></b>
<form method="post" action=index.php?mod= <?php
		echo $_FN['mod']?>>
	<?php
		echo _NAME?>:<input size="8" type="text" name="dirname" />&nbsp;
	<?php
		echo _TITLE?>:<input type="text" name="title" /> <input
	type="submit" class="submit" name="newdir" value="<?php
		echo _CREA?>" />
</form>
</span>
<?php
	}
	if ( isset($_POST['send']) )
	{
		$fileToOpen = $_FN['datadir'] . "/Download/" . $location;
		$file_clean = strippostpslashes($_FILES['filename']['name']);
		if (  !move_uploaded_file($_FILES['filename']['tmp_name'],$fileToOpen . "/" . $file_clean) )
		{
			echo "<br />Error: $fileToOpen -> $file_clean<br />";
		}
	}
}
if ( isset($_GET['mode']) && $_GET['mode'] == "go" )
{
	header("location:sections/" . $_FN['vmod'] . "/getfile.php?f=$downloadfile");
	//go_download($downloadfile);
}
else
	view_download("");
return;
/**
 *
 *
 * Permette di scaricare un file dalle sezione "Download" gestendone
 * il conteggio dei downloads.
 * @param string $file Nome assoluto del file da scaricare
 */
function go_download($file)
{
	global $_FN;
	// evita di accedere a directory esterne
	if ( stristr($file,"..") )
		die(_NONPUOI);
		// se il file non esiste lo crea
	if (  !file_exists($_FN['datadir'] . "/fndatabase/download.php") )
	{
		$fields = array();
		$fields[1]['name'] = "filename";
		$fields[1]['primarykey'] = "1";
		$fields[2]['name'] = "numdownload";
		$fields[2]['defaultvalue'] = "0";
		createxmltable("fndatabase","download",$fields,$_FN['datadir'],"download");
	}
	$stat = new XMLTable("fndatabase","download",$_FN['datadir']);
	$oldval = $stat->GetRecordByPrimaryKey($file);
	$r['filename'] = $file;
	if ( $oldval == null )
	{
		$r['numdownload'] = 1;
		$stat->InsertRecord($r);
	}
	else
	{
		//incrementa download
		$r['numdownload'] = $oldval['numdownload'] + 1;
		$stat->UpdateRecord($r);
	}
	if ( get_file_extension($file) == "link" )
	{
		Header("Location: " . file_get_contents($_FN['datadir'] . "/Download/$file"));
	}
	else
		Header("Location: " . $_FN['datadir'] . "/Download/$file");
}
/**
 * Visualizza tutte le classi di download
 *
 * Visualizza tutte le classi di download filtrate secondo il parametro $filter
 * presenti nella directory <i>/sections/Download/</i>, stampandone l'eventuale
 * descrizione.
 *
 * @author Simone Vellei <simone_vellei@users.sourceforge.net>
 *
 * @param string $filter Filtro per le classi di download
 */
function view_download($filter)
{
	global $_FN;
	global $show_stats;
	$sectionslist = array();
	if ( $filter != "" )
		echo ("<p>$filter</p>");
		// crea elenco di tutte le sezioni presenti
	$handle = opendir($_FN['datadir'] . "/Download");
	while (false !== ($file = readdir($handle)))
	{
		if (  !($file == "." or $file == "..") and ( !preg_match("/^\\./s",$file) and ($file != "CVS") and is_dir($_FN['datadir'] . "/Download/$file")) )
		{
			if ( ($filter == "") or stristr($file,$filter) )
			{
				array_push($sectionslist,$file);
			}
		}
	}
	closedir($handle);
	sort($sectionslist);
	//tabella statistiche
	$stat = new XMLTable("fndatabase","download",$_FN['datadir']);
	echo "<br />";
	foreach ( $sectionslist as $downloadsection )
	{
		//echo "<li>";
		OpenTableTitle("<img style=\"vertical-align: middle;border:0px\" alt=\"\"  src=\"" . fromtheme("images/section.png") . "\" />&nbsp;" . "<b>" . htmlentities($downloadsection) . "</b>");
		//-------sezone-------
		//echo "<b><img style=\"vertical-align: middle;border:0px;\" alt=\"\"  src=\"".fromtheme("images/section.png")."\" />&nbsp;";
		//echo "" . htmlentities($downloadsection) . "</b>";
		$filedescr = $_FN['datadir'] . "/Download/" . $downloadsection . "/description.{$_FN['lang']}.html";
		if ( file_exists($filedescr) )
		{
			echo "<em>" . htmlentities(file_get_contents($filedescr)) . "</em><br />";
		}
		$modlist_down = array();
		$handle_down = opendir($_FN['datadir'] . "/Download/" . $downloadsection);
		while (false !== ($file = readdir($handle_down)))
		{
			if (  !($file == "." || $file == "..") && ( !preg_match("/^\\./s",$file) && ($file != "CVS") && ( !preg_match("/^description./si",$file))) )
			{
				array_push($modlist_down,$file);
			}
		}
		closedir($handle_down);
		if ( isadmin() && $_FN['fneditmode'] != 0 )
		{
			if ( count($modlist_down) == 0 )
				echo " [<a href=\"javascript:check('index.php?mod={$_FN['vmod']}&amp;filename=" . $_FN['datadir'] . "/Download/" . htmlentities(addslashes($downloadsection),ENT_QUOTES) . "&amp;deldir=1')\">" . _ELIMINA . "</a>]";
			?>
<span class="flatnukeadmin">
<form method="post" action="?mod=<?php
			echo $_FN['vmod']?>">
				<?php
			echo _TITLE?>:<textarea rows="1" cols="30" name="title"><?php
			echo htmlentities(@file_get_contents($filedescr),ENT_QUOTES);
			?></textarea>
<input type="hidden" name="filename"
	value="<?php
			echo htmlentities($filedescr,ENT_QUOTES)?>"> <input
	type="submit" class="submit" value="<?php
			echo _CHANGE?>"
	name="changetitle"></form>
</span>
<?php
		}
		sort($modlist_down);
		foreach ( $modlist_down as $downloadfile )
		{
			$downloadlink = "index.php?mod={$_FN['vmod']}&amp;downloadfile=" . htmlentities($downloadsection,ENT_QUOTES) . "/" . htmlentities($downloadfile,ENT_QUOTES) . "&amp;mode=go";
			echo "<br />&nbsp;&nbsp;&nbsp;&nbsp;";
			$dimg = fn_GetIconByFilename($downloadfile);
			echo "<a href=\"$downloadlink\">";
			echo "<img style=\"vertical-align: middle;border:0px;\" alt=\"download " . htmlentities($downloadfile) . "\"  src=\"$dimg\" " . "/></a>&nbsp;" . "<a title=\"download $downloadfile\" href=\"$downloadlink\" " . ">" . "$downloadfile" . "</a> ";
			$fsize = filesize($_FN['datadir'] . "/Download/" . $downloadsection . "/" . $downloadfile);
			$suff = "bytes";
			if ( $fsize > 1024 )
			{
				$fsize = round($fsize / 1024,2);
				$suff = "Kb";
			}
			if ( $fsize > 1024 )
			{
				$fsize = round($fsize / 1024,2);
				$suff = "Mb";
			}
			$filetodown = $downloadsection . "/" . $downloadfile;
			$val = $stat->GetRecordByPrimaryKey($filetodown);
			//dprint_r($stat);
			$count = isset($val['numdownload']) ? $val['numdownload'] : 0;
			if ( is_admin() || $show_stats == 1 )
			{
				$st = " | $count Download";
			}
			echo "&nbsp;($fsize $suff$st) ";
			if ( is_admin() )
				echo "[<a href=\"javascript:check('verify.php?mod=delcontents&amp;file=" . $_FN['datadir'] . "/Download/" . htmlentities(($downloadsection),ENT_QUOTES) . "/" . htmlentities(($downloadfile),ENT_QUOTES) . "')\" >" . _ELIMINA . "</a>]";
			echo "<br />";
		}
		echo "<br />";
		if ( isadmin() && $_FN['fneditmode'] != 0 )
		{
			?>
<span class="flatnukeadmin">
<form enctype="multipart/form-data" method="post"
	action="?mod=<?php
			echo $_FN['vmod']?>" />
			<?php
			echo _SENDFILE?> : <input type="file" name="filename"
	value="upload" /> <input type="hidden" name="MAX_FILE_SIZE"
	value="1000000" /> <input type="submit" value="<?php
			echo _FINVIA?>"
	name="send" /> <input type="hidden"
	value="<?php
			echo htmlentities($downloadsection,ENT_QUOTES)?>"
	name="location" /></form>
</span>
<?php
		}
		CloseTableTitle();
		echo "<br />";
	}
}
//fine download
?>
