<?php
/**
 * section.php Created on 28-mag-2007
 * @package flatnux_section_links
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 */
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}
global $_FN;
global $_FNMESSAGE;
//------------------------INIT--------------------->
//----------------links------------------
if (  !file_exists("{$_FN['datadir']}/fndatabase/links.php") )
{
	$fields = array();
	//usename -non eliminare
	$fields[1]['name'] = "id";
	$fields[1]['primarykey'] = "1";
	$fields[1]['extra'] = "autoincrement";
	$fields[1]['frm_show'] = "0";
	//Titolo
	$fields[2]['name'] = "title";
	$fields[2]['frm_it'] = "Titolo";
	$fields[2]['frm_help_it'] = "Immetti il titolo del link qui";
	$fields[2]['frm_en'] = "Title";
	$fields[2]['frm_es'] = "Title";
	$fields[2]['frm_de'] = "Title";
	$fields[2]['frm_required'] = "1";
	$fields[2]['unique'] = "1";
	//link
	$fields[3]['name'] = "link";
	$fields[3]['frm_it'] = "Link";
	$fields[3]['frm_en'] = "Link";
	$fields[3]['frm_es'] = "Link";
	$fields[3]['frm_de'] = "Link";
	$fields[3]['frm_help_it'] = "URL del tuo sito";
	$fields[3]['frm_default'] = "http://";
	//categoria
	$fields[4]['name'] = "category";
	$fields[4]['frm_required'] = "1";
	$fields[4]['frm_it'] = "Categoria";
	$fields[4]['frm_en'] = "Category";
	$fields[4]['frm_es'] = "Category";
	$fields[4]['frm_de'] = "Category";
	$fields[4]['foreignkey'] = "linksgropus";
	$fields[4]['fk_show_field'] = "title";
	$fields[4]['fk_link_field'] = "id";
	$fields[4]['frm_show_image'] = "image";
	//avatar
	$fields[5]['name'] = "avatar";
	$fields[5]['type'] = "image";
	$fields[5]['frm_it'] = "Avatar";
	$fields[5]['frm_en'] = "Avatar";
	$fields[5]['frm_es'] = "Avatar";
	$fields[5]['frm_de'] = "Avatar";
	$fields[5]['frm_help_it'] = "Qui puoi uplodare una piccola immagine (massimo 80x80) che identificha il link";
	$fields[5]['frm_maximagesize'] = "800";
	$fields[5]['thumbsize'] = "24";
	echo createxmltable("fndatabase","links",$fields,"{$_FN['datadir']}");
}
//----------------linksgropus------------------
if (  !file_exists("{$_FN['datadir']}/fndatabase/linksgropus.php") )
{
	$fields = array();
	//usename -non eliminare
	$fields[1]['name'] = "id";
	$fields[1]['primarykey'] = "1";
	$fields[1]['extra'] = "autoincrement";
	$fields[1]['frm_show'] = "0";
	//Titolo
	$fields[2]['name'] = "title";
	$fields[2]['frm_it'] = "Titolo";
	$fields[2]['frm_help_it'] = "Immetti il titolo del gruppo qui";
	$fields[2]['frm_en'] = "Title";
	$fields[2]['frm_es'] = "Title";
	$fields[2]['frm_de'] = "Title";
	$fields[2]['frm_required'] = "1";
	$fields[2]['unique'] = "1";
	//Immagine
	$fields[3]['name'] = "image";
	$fields[3]['type'] = "image";
	$fields[3]['frm_it'] = "Immagine";
	$fields[3]['frm_help_it'] = "Immetti un immagine per questa categoria";
	$fields[3]['frm_en'] = "Image";
	$fields[3]['frm_es'] = "Image";
	$fields[3]['frm_de'] = "Image";
	$fields[3]['frm_required'] = "0";
	$fields[3]['unique'] = "0";
	$fields[3]['frm_maximagesize'] = "800";
	$fields[3]['thumbsize'] = "24";
	echo createxmltable("fndatabase","linksgropus",$fields,"{$_FN['datadir']}");
}
//<------------------------INIT---------------------
$opmod = getparam("opmod",PAR_GET,SAN_FLAT);
switch ($opmod)
{
	case "addlinksgropus" :
		$tablegroup = new FieldForm("fndatabase","linksgropus",$_FN['datadir'],$_FN['lang']);
		$tablelinks = new FieldForm("fndatabase","links",$_FN['datadir'],$_FN['lang']);
		$newvalues = $tablegroup->getbypost();
		$err = $tablegroup->Verify($newvalues);
		if ( $err != "" )
		{
			echo _FERRCAMPO . ":<br /><br />";
			echo $err . "<br />";
			$tit = _INDIETRO;
			echo "<a accesskey=" . getaccesskey($tit,"javascript:history.back()") . " href=\"javascript:history.back()\">&lt;&lt;$tit</a>";
		}
		else
		{
			echo $_FNMESSAGE['recordinserito'];
			$tablegroup->xmltable->InsertRecord($newvalues);
		}
	break;
	case "addlinks" :
		$tablegroup = new FieldForm("fndatabase","linksgropus",$_FN['datadir'],$_FN['lang']);
		$tablelinks = new FieldForm("fndatabase","links",$_FN['datadir'],$_FN['lang']);
		$newvalues = $tablelinks->getbypost();
		$err = $tablelinks->Verify($newvalues);
		if ( $err != "" )
		{
			echo _FERRCAMPO . ":<br /><br />";
			echo $err . "<br />";
			$tit = _INDIETRO;
			echo "<a accesskey=" . getaccesskey($tit,"javascript:history.back()") . " href=\"javascript:history.back()\">&lt;&lt;$tit</a>";
		}
		else
		{
			$tablelinks->xmltable->InsertRecord($newvalues);
			echo $_FNMESSAGE['recordinserito'] . "<br />";
			PrintLinks();
		}
	break;
	case "addcategory" :
		if ( is_link_admin() )
		{
			$tablegroup = new FieldForm("fndatabase","linksgropus",$_FN['datadir'],$_FN['lang']);
			$tablelinks = new FieldForm("fndatabase","links",$_FN['datadir'],$_FN['lang']);
			echo "\n<form method=\"post\" enctype=\"multipart/form-data\" action=\"?mod={$_FN['mod']}&opmod=addlinksgropus\" >";
			echo "\n<table>";
			echo "\n<tr><td colspan=\"2\">" . "Gruppi" . "</tr></td>";
			$tablegroup->ShowInsertForm();
			echo "\n<tr><td colspan=\"2\"><input class=\"submit\" type=\"submit\" value=\"" . _SAVE . "\"/>";
			echo "<input type='button' class='button' onclick='window.location=(\"index.php?mod={$_FN['mod']}\")'  value='" . _CANCEL . "' />";
			echo "</tr></td>";
			echo "\n";
			echo "\n";
			echo "\n";
			echo "\n";
			echo "\n</table>";
			echo "\n</form>";
		}
	break;
	case "modcategory" :
		if ( is_link_admin() )
		{
			$id = getparam("id",PAR_GET,SAN_FLAT);
			if ( $id != "" )
			{
				$tablegroup = new FieldForm("fndatabase","linksgropus",$_FN['datadir'],$_FN['lang']);
				$tablelinks = new FieldForm("fndatabase","links",$_FN['datadir'],$_FN['lang']);
				echo "\n<form method=\"post\" enctype=\"multipart/form-data\" action=\"?mod={$_FN['mod']}&opmod=doupdatelinksgropus\" >";
				echo "\n<table>";
				echo "\n<tr><td colspan=\"2\">" . "Gruppi" . "</tr></td>";
				$tablegroup->ShowUpdateForm($id);
				echo "\n<tr><td colspan=\"2\"><input class=\"submit\" type=\"submit\" value=\"" . _SAVE . "\"/>";
				echo "<input type='button' class='button' onclick='window.location=(\"index.php?mod={$_FN['mod']}\")'  value='" . _CANCEL . "' />";
				echo "</tr></td>";
				echo "\n";
				echo "\n";
				echo "\n";
				echo "\n";
				echo "\n</table>";
				echo "\n</form>";
			}
		}
	break;
	case "modlink" :
		if ( is_link_admin() )
		{
			$id = getparam("id",PAR_GET,SAN_FLAT);
			if ( $id != "" )
			{
				$tablegroup = new FieldForm("fndatabase","linksgropus",$_FN['datadir'],$_FN['lang']);
				$tablelinks = new FieldForm("fndatabase","links",$_FN['datadir'],$_FN['lang']);
				echo "\n<form method=\"post\" enctype=\"multipart/form-data\" action=\"?mod={$_FN['mod']}&opmod=doupdatelinks\" >";
				echo "\n<table>";
				echo "\n<tr><td colspan=\"2\">" . "Gruppi" . "</tr></td>";
				$tablelinks->ShowUpdateForm($id);
				echo "\n<tr><td colspan=\"2\"><input class=\"submit\" type=\"submit\" value=\"" . _SAVE . "\"/>";
				echo "<input type='button' class='button' onclick='window.location=(\"index.php?mod={$_FN['mod']}\")'  value='" . _CANCEL . "' />";
				echo "</tr></td>";
				echo "\n";
				echo "\n";
				echo "\n";
				echo "\n";
				echo "\n</table>";
				echo "\n</form>";
			}
		}
	break;
	case "addlink" :
		if ( is_link_admin() )
		{
			$tablelinks = new FieldForm("fndatabase","links",$_FN['datadir'],$_FN['lang']);
			echo "\n<form method=\"post\" enctype=\"multipart/form-data\" action=\"?mod={$_FN['mod']}&opmod=addlinks\" >";
			echo "\n<table>";
			echo "\n<tr><td colspan=\"2\">" . "Links" . "</tr></td>";
			$tablelinks->ShowInsertForm();
			echo "\n<tr><td colspan=\"2\"><input class=\"submit\" type=\"submit\" value=\"" . _SAVE . "\"/>";
			echo "<input type='button' class='button' onclick='window.location=(\"index.php?mod={$_FN['mod']}\")'  value='" . _CANCEL . "' />";
			echo "</tr></td>";
			echo "\n";
			echo "\n";
			echo "\n";
			echo "\n</table>";
			echo "\n</form>";
		}
	break;
	case "doupdatelinksgropus" :
		if ( is_link_admin() )
		{
			$tablegroup = new FieldForm("fndatabase","linksgropus",$_FN['datadir'],$_FN['lang']);
			$tablelinks = new FieldForm("fndatabase","links",$_FN['datadir'],$_FN['lang']);
			$newvalues = $tablegroup->getbypost();
			$err = $tablegroup->Verify($newvalues,true);
			if ( $err != "" )
			{
				echo _FERRCAMPO . ":<br /><br />";
				echo $err . "<br />";
				$tit = _INDIETRO;
				echo "<a accesskey=" . getaccesskey($tit,"javascript:history.back()") . " href=\"javascript:history.back()\">&lt;&lt;$tit</a>";
			}
			else
			{
				echo $_FNMESSAGE['recordaggiornato'] . "<br />";
				$tablegroup->xmltable->UpdateRecord($newvalues);
			}
		}
		PrintLinks();
	break;
	case "doupdatelinks" :
		if ( is_link_admin() )
		{
			$tablegroup = new FieldForm("fndatabase","linksgropus",$_FN['datadir'],$_FN['lang']);
			$tablelinks = new FieldForm("fndatabase","links",$_FN['datadir'],$_FN['lang']);
			$newvalues = $tablelinks->getbypost();
			$err = $tablelinks->Verify($newvalues,true);
			if ( $err != "" )
			{
				echo _FERRCAMPO . ":<br /><br />";
				echo $err . "<br />";
				$tit = _INDIETRO;
				echo "<a accesskey=" . getaccesskey($tit,"javascript:history.back()") . " href=\"javascript:history.back()\">&lt;&lt;$tit</a>";
			}
			else
			{
				echo $_FNMESSAGE['recordaggiornato'] . "<br />";
				$tablelinks->xmltable->UpdateRecord($newvalues);
			}
		}
		PrintLinks();
	break;
	case "dellink" :
		if ( is_link_admin() )
		{
			$id = getparam("id",PAR_GET,SAN_FLAT);
			if ( $id != "" )
			{
				$tablelinks = new FieldForm("fndatabase","links",$_FN['datadir'],$_FN['lang']);
				$tablelinks->xmltable->DelRecord($id);
				echo $_FNMESSAGE['recordeliminato'] . "<br />";
			}
		}
		PrintLinks();
	break;
	default :
		PrintLinks();
	break;
}
global $_FN;
$opmod = getparam("opmod",PAR_GET,SAN_FLAT);
if ( is_link_admin() && $opmod != "addcategory" && $opmod != "addlink" && $_FN['fneditmode'] )
{
	echo "<div class=\"flatnukeadmin\">";
	echo "<a href=\"index.php?mod={$_FN['mod']}&amp;opmod=addcategory\">" . $_FNMESSAGE['addcategory'] . "</a>";
	echo "</div>";
	$tablegroup = new FieldForm("fndatabase","linksgropus",$_FN['datadir'],$_FN['lang']);
	if ( $tablegroup->xmltable->GetNumRecords() > 0 )
	{
		echo "<div class=\"flatnukeadmin\">";
		echo "<a href=\"index.php?mod={$_FN['mod']}&amp;opmod=addlink\">" . $_FNMESSAGE['addlink'] . "</a>";
		echo "</div>";
	}
}
/**
 * print links
 *
 */
function PrintLinks()
{
	global $_FNMESSAGE;
	global $_FN;
	//----stampa i links--->
	$tablegroup = new FieldForm("fndatabase","linksgropus",$_FN['datadir'],$_FN['lang']);
	$tablelinks = new FieldForm("fndatabase","links",$_FN['datadir'],$_FN['lang']);
	{
		$gropus = $tablegroup->xmltable->GetRecords();
		if ( is_array($gropus) )
			foreach ( $gropus as $grop )
			{
				$r['category'] = $grop['id'];
				$links = $tablelinks->xmltable->GetRecords($r);
				if ( is_array($links) && count($links) > 0 )
				{
					echo "<h3>";
					if ( isset($grop['image']) && $grop['image'] != "" )
					{
						echo "<img alt=\"\" style=\"vertical-align:middle\" src=\"{$_FN['datadir']}/fndatabase/linksgropus/" . $grop['id'] . "/image/thumbs/" . $grop['image'] . ".jpg\" />&nbsp;";
					}
					echo $grop['title'];
					if ( is_link_admin() && $_FN['fneditmode'] )
					{
						echo "&nbsp;<span ><a href=\"index.php?mod={$_FN['mod']}&amp;opmod=modcategory&amp;id=" . $grop['id'] . "\"  >[" . _MODIFICA . "]</a></span>";
					}
					echo ":</h3>" . "";
					foreach ( $links as $link )
					{
						if ( isset($link['avatar']) && $link['avatar'] != "" )
						{
							$st = tooltip("<img alt=\"\" src=\"{$_FN['datadir']}/fndatabase/links/" . $link['id'] . "/avatar/" . $link['avatar'] . "\" />");
							echo "<img alt=\"\" $st style=\"vertical-align:middle\" src=\"{$_FN['datadir']}/fndatabase/links/" . $link['id'] . "/avatar/thumbs/" . $link['avatar'] . ".jpg\" />&nbsp;";
						}
						echo "<a href=\"" . $link['link'] . "\" onclick=\"window.open(this.href);return false;\" >" . $link['title'] . "</a>";
						if ( is_link_admin() && $_FN['fneditmode'] )
						{
							echo "&nbsp;<span ><a href=\"index.php?mod={$_FN['mod']}&amp;opmod=modlink&amp;id=" . $link['id'] . "\"  >[" . _MODIFICA . "]</a></span>";
							echo "&nbsp;<span ><a href=\"javascript:check('index.php?mod={$_FN['mod']}&amp;opmod=dellink&amp;id=" . $link['id'] . "')\"  >[" . _ELIMINA . "]</a></span>";
						}
						echo "<br />";
					}
				}
			}
	}
	//<----stampa i links---
}
function is_link_admin()
{
	global $_FN;
	$link_group = "";
	include ("sections/" . $_FN['vmod'] . "/config.php");
	if ( $link_group == "" )
		return is_admin();
	return (is_admin() || user_in_group($_FN['user'],$link_group));
}
?>