<?php
/**
 * INFO.php
 * 
 * Created on 12-feb-2007
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * 
 * @copyright Copyright (c) 2007
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 * 
 */
if ( !file_exists("./index.php") || !file_exists("./sections") )
	die();
global $_FN;
$search = htmlspecialchars(getparam("q", PAR_GET, SAN_FLAT));
$opt = getparam("opt", PAR_GET, SAN_FLAT);
$files = glob($_FN['datadir'] . "/log/*-log.php");
$res = array();
if ( is_array($files) )
{
	sort($files, SORT_REGULAR);
	foreach ( $files as $file )
	{
		$tmp = get2DArrayFromCsv($file, ";");
		unset($tmp[0]);
		foreach ( $tmp as $row )
		{
			if ( $search != "" )
				if ( !stristr(implode(",", $row), $search) )
					continue;
			$tmpres['Data'] = $row[0];
			$tmpres['IP'] = $row[1];
			$tmpres['Self'] = $row[2];
			$tmpres['Section'] = $row[3];
			$tmpres['User'] = $row[4];
			$tmpres['Text'] = $row[5];
			$res[] = $tmpres;
		}
	}
}
//vecchi log --->
$res2 = get_old_logs();
foreach ( $res2 as $row )
{
	if ( $search != "" )
		if ( !stristr(implode(",", $row), $search) )
			continue;
	$res[] = $row;
}
//vecchi log ---<
//---ricerca testo---->
echo "<form method=\"get\" action=\"?opt=$opt&amp;mod={$_FN['mod']}\">";
echo "<input type=\"hidden\" name=\"mod\" value=\"{$_FN['mod']}\" />";
echo "<input type=\"hidden\" name=\"opt\" value=\"$opt\" />";
echo "<input type=\"text\" name=\"q\" value=\"" . htmlspecialchars($search) . "\" />";
echo "&nbsp;<input type=\"submit\" value=\"" . _CERCA . "\"/></form>";
//---ricerca testo----<
printTable($res);
function get2DArrayFromCsv($file, $delimiter)
{
	if ( ($handle = fopen($file, "r")) !== FALSE )
	{
		$i = 0;
		while ( ($lineArray = fgetcsv($handle, 4000, $delimiter)) !== FALSE )
		{
			for ( $j = 0; $j < count($lineArray); $j++ )
			{
				$data2DArray[$i][$j] = $lineArray[$j];
			}
			$i++;
		}
		fclose($handle);
	}
	return $data2DArray;
}
function get_old_logs()
{
	global $_FN;
	$res = array();
	$files = glob($_FN['datadir'] . "/log/log.php.*");
	if ( is_array($files) )
		sort($files, SORT_REGULAR);
	else
		$files = array();
	$files[] = $_FN['datadir'] . "/log/log.php";
	foreach ( $files as $file )
	{
		if (  file_exists($file))
		{
			$all = file($file);
			for ( $cf = 1; $cf < count($all); $cf++)
			{
				$row = $all[$cf];
				$cols = explode("||", $row);
				$tmpres['Data'] = "";
				$tmpres['IP'] = "";
				$tmpres['Self'] = "";
				$tmpres['Section'] = "";
				$tmpres['User'] = "";
				$tmpres['Text'] = "";
				//dprint_r($cols);
				if ( count($cols) == 3 )
				{
					$tmpres['User'] = $cols[1];
					$tmpres['Text'] = trim(ltrim($cols[2]," \n\r")," \n\r");
					$tmpdate = $cols[0];
					$tmpres['Data'] =  $tmpdate[6] . $tmpdate[7] . $tmpdate[8] . $tmpdate[9] . "-".$tmpdate[3] . $tmpdate[4] . "-" . $tmpdate[0] . $tmpdate[1]." " . substr($tmpdate, 11,8);
				}
				else
				{
					$text = trim(ltrim(implode(",", $cols)," \n\r")," \n\r");
					$tmpres['Text'] = $text;
				}
				if ($tmpres['Text'] != "")
				{
					$res[] = $tmpres;
				}
			}
		}
	}
	return $res;
}
/**
 * print table
 * @param array $res
 */
function printTable($res)
{
	global $_FN;
	echo "<div id=\"tb\">";
	$recordsperpage = 50;
	$thcolor = "#efebde";
	$bgcolor = "#ffffff";
	$bgcolor2 = "#dadada";
	$textcolor = "#000000";
	if ( is_array($res) && count($res) > 0 )
	{
		$first = true;
		echo "
<script type=\"text/javascript\">
trh = function (over,elem){
	var old;
	if (over){
		old = elem.style.backgroundColor
		elem.style.backgroundColor='$bgcolor2';
	}
	else{
		elem.style.backgroundColor='$bgcolor';
	}
}
checkdelete = function (url){
	if(confirm (\"Conferma cancellazione\"))
		window.location=url;
}
</script>
";
		$page = getparam("page", PAR_GET, SAN_FLAT);
		$order = getparam("order", PAR_GET, SAN_FLAT);
		if ( $order != "" )
		{
			$res = array_sort_by_key($res, $order);
		}
		$numPages = 1;
		$start = 0;
		$end = 0;
		if ( $recordsperpage != false )
		{
			$num_records = count($res);
			if ( $page == "" )
				$page = 1;
			$numPages = ceil($num_records / $recordsperpage);
			if ( $page > $numPages )
				$page = $numPages;
			$start = ($page * $recordsperpage - $recordsperpage);
			$end = $start + $recordsperpage - 1;
		}
		$htmlpages = "";
		if ( $numPages > 1 )
		{
			$htmlpages = "Pagina: ";
			for ( $i = 1; $i <= $numPages; $i++ )
			{
				if ( $i == $page )
					$htmlpages .= "<a onclick=\"to_ajax(this,'tb');return false;\" href=\"" . get_link(array("page" => $i)) . "\"><b>$i</b></a> ";
				else
					$htmlpages .= "<a onclick=\"to_ajax(this,'tb');return false;\"  href=\"" . get_link(array("page" => $i)) . "\">$i</a> ";
			}
		}
		echo $htmlpages;
		echo "\n<table width=\"100%\" cellpadding=\"4\" cellspacing=\"1\" border=\"0\" style=\"background-color:#dadada\">";
		$i = 1;
		foreach ( $res as $row )
		{
			if ( $first )
			{
				echo "\n<tr>";
				foreach ( $row as $k => $v )
					echo "\n\t<td style=\"background-color:$thcolor;color:#000000\" ><a onclick=\"return to_ajax(this,'tb');\" href=\"" . get_link(array("order" => "$k")) . "\">" . htmlspecialchars($k) . "</a></td>";
				echo "</tr>";
			}
			$i++;
			if ( $end == 0 || ($i > $start && $i < $end) )
			{
				echo "\n<tr onmouseover=\"trh(1,this)\" onmouseout=\"trh(0,this)\" style=\"color:#000000;background-color:$bgcolor\" >";
				foreach ( $row as $k => $v )
				{
					echo "\n\t<td style=\"color:#000000;text-align:left\">" . ($v) . "</td>";
				}
				echo "\n</tr>";
			}
			$first = false;
		}
		echo "\n</table>";
		echo $htmlpages;
		//echo "</tb>";
	}
}
/**
 * genera un link
 * @param array $values
 * @param string $sep
 */
function get_link($values = false, $sep = "&amp;")
{
	global $_FN;
	$link['opt'] = getparam("opt", PAR_GET, SAN_FLAT);
	$link['op'] = getparam("op", PAR_GET, SAN_FLAT);
	$link['q'] = htmlspecialchars(getparam("q", PAR_GET, SAN_FLAT));
	$link['order'] = htmlspecialchars(getparam("order", PAR_GET, SAN_FLAT));

	if ( $values )
		foreach ( $values as $k => $v )
		{
			$link[$k] = urlencode($v);
		}
	$linkclean = "";
	foreach ( $link as $k => $v )
	{
		if ( $v != "" )
			$linkclean .= "$sep$k=$v";
	}
	$linkclean = "?mod={$_FN['mod']}$linkclean";
	return $linkclean;
}
?>