<?php
/**
 * blocks.php
 * 
 * Created on 13-feb-2007
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * 
 * @copyright Copyright (c) 2007
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 * 
 */
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']), strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}
global $_FN, $languages;
$op = getparam("opt", PAR_GET, SAN_FLAT);
$editblock = getparam("editblock", PAR_GET, SAN_FLAT);
$delblock = getparam("delblock", PAR_GET, SAN_FLAT);
//echo "blocks/$where/$delblock";
//-----eliminazione di un blocco ------->
$where = getparam("where", PAR_GET, SAN_FLAT);
if ( $delblock != "" && $where != "" && file_exists("blocks/$where/$delblock") )
{
	$filelang = preg_replace("/^[0-9]+_|^none_/si", "", basename($delblock) . ".xml");
	unlink("blocks/$where/$delblock");
	if ( file_exists("blocks/$where/$filelang") )
		unlink("blocks/$where/$filelang");
	jsredirect("?mod={$_FN['mod']}&opt=$op");
}
//-----eliminazione di un blocco -------<
//-----modifica titolo di un blocco ------->
//dprint_r($_POST);
for ( $m = 0; isset($_POST[$m . '_where']); $m++ )
{
	$modify = getparam($m . "_modify", PAR_POST, SAN_FLAT);
	if ( $modify != "" )
	{
		$where = getparam($m . "_where", PAR_POST, SAN_FLAT);
		$oldwhere = getparam($m . "_oldwhere", PAR_POST, SAN_FLAT);
		$pos = getparam($m . "_pos", PAR_POST, SAN_FLAT);
		//dprint_r($pos);
		if ( $pos != "" )
		{
			$newname = "blocks/$where/" . preg_replace("/^[0-9]+_|^none_/si", $pos . "_", $modify);
			//dprint_r($newname);
			//dprint_r("blocks/$oldwhere/$modify");
			if ( !file_exists($newname) )
			{
				if ( file_exists("blocks/$oldwhere/$modify") )
					rename("blocks/$oldwhere/$modify", $newname);
			}
			$ll = explode(',', $languages);
			foreach ( $ll as $l )
			{
				$tmp = preg_replace("/^[0-9]+_|^none_/si", "", $modify);
				if ( isset($_POST[$m . '_title_' . $l]) && $_POST[$m . '_title_' . $l] != "" )
					set_section_title("blocks/$where/$tmp.xml", strippostpslashes($_POST[$m . '_title_' . $l]), $l);
			}
		}
	}
}
if ( $m > 0 )
	jsredirect("?mod={$_FN['mod']}&opt=$op");
//-----modifica titolo di un blocco -------<
//-------------------MODIFICA O FORM----------------->
if ( $editblock != "" && file_exists("blocks/$editblock") )
{
	edit_content("blocks/$editblock", "{$_FN['self']}?mod={$_FN['mod']}&opt=$op");
}
else
	showblocksoptions();
//<-------------------MODIFICA O FORM-----------------
function showblocksoptions()
{
	global $_FN, $_FNMESSAGE;
	$op = getparam("opt", PAR_GET, SAN_FLAT);
	//$blocktomovedx = getparam ( "sx", PAR_POST, SAN_FLAT );
	//$blocktomovesx = getparam ( "dx", PAR_POST, SAN_FLAT );
	$newblock = getparam("newblock", PAR_POST, SAN_FLAT);
	if ( isset($_POST['newblock']) && ($newblock == "") )
		jsalert(fn_i18n("_FERRCAMPO"));
	// scansiono la cartella blocks (dovrebbe tornare dx,sx)
	$handlebl = opendir("blocks");
	$dxsx = array();
	while ( false !== $d = readdir($handlebl) )
	{
		if ( $d != "." && $d != ".." && is_dir("blocks/$d") )
		{
			$dxsx[] = $d;
		}
	}
	closedir($handlebl);
	//------------creazione blocco----------------->
	global $languages;
	$ll = explode(",", $languages);
	$where = getparam("where", PAR_POST, SAN_FLAT);
	$prefix = getparam("prefix", PAR_POST, SAN_FLAT);
	$bext = getparam("ext", PAR_POST, SAN_FLAT);
	if ( $newblock != "" && !fn_is_external_referer() )
	{
		if ( file_exists("blocks/$where/$prefix$newblock.$bext") )
		{
			echo "<br />" . _FIG_ALERTEXIST . "";
		}
		else
		{
			if ( $prefix != "" )
				$prefix .= "_";
			if ( in_array($where, $dxsx) )
			{
				$str = "";
				if ( $bext == "php" )
				{
					$str = "if ( strpos(strtolower(\$_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	header(\"Location:../../index.php\");
	die ();
}
";
				}
				else
				{
					if ( $bext == "menu" )
					{
						//($path, $menu_recursive, $show_icons, $menu_recursive_onlyselected)
						$path = getparam("path", PAR_POST, SAN_FLAT);
						$show_icons = getparam("show_icons", PAR_POST, SAN_FLAT);
						$menu_recursive = getparam("menu_recursive", PAR_POST, SAN_FLAT);
						$menu_recursive_onlyselected = getparam("menu_recursive_onlyselected", PAR_POST, SAN_FLAT);
						$sep = getparam("sep", PAR_POST, SAN_FLAT);
						$str = "$path,$menu_recursive,$show_icons,$menu_recursive_onlyselected,$sep";
					}
					elseif ( $bext == "html" )
					{
						$str = "<p></p>";
					}
				}
				$f = fopen("blocks/$where/$prefix$newblock.$bext", "w");
				fwrite($f, $str);
				$str = "<title>";
				foreach ( $ll as $l )
				{
					$tit = getparam("title_$l", PAR_POST, SAN_FLAT);
					$str .= "\n\t<$l>" . htmlentities($tit) . "</$l>";
				}
				$str .= "\n</title>";
				$f = fopen("blocks/$where/$newblock.$bext.xml", "w");
				fwrite($f, $str);
				fclose($f);
				if ( $bext != "menu" )
				{
					edit_content("blocks/$where/$prefix$newblock.$bext");
				}
			}
		}
	}
	echo "<form method=\"post\" action=\"?mod={$_FN['mod']}&amp;opt=$op\"\" >";
	echo "<fieldset>";
	echo "<legend>" . $_FNMESSAGE['CC_NEWBLOCK'] . "</legend>";
	echo "<table>";
	echo "\n<tr><td>" . _POS . ":</td><td> ";
	foreach ( $dxsx as $blwhere1 )
	{
		$c = "";
		if ( !empty($_POST['where']) && $_POST['where'] == $blwhere1 )
		{
			$c = "checked=\"checked\"";
		}
		else
		{
			if ($blwhere1=="sx")
				$c = "checked=\"checked\"";
		}
		$icon = get_icon_blocks($blwhere1);
		echo "<span style=\"border:1px inset #d0d0d0;padding:3px;\">$icon<input style=\"vertical-align:middle\" $c type=\"radio\"  name=\"where\" value=\"$blwhere1\" /></span>&nbsp;&nbsp;&nbsp;&nbsp;";
	}
	echo "</td></tr>";
	echo "\n<tr><td>" . _UNINAME . ":</td><td> <input type=\"text\"  name=\"newblock\" value=\"\" /></td></tr>";
	echo "\n<tr><td>" . _PREFIX_INDEX . ":</td><td> ";
	echo "<select name=\"prefix\" title=\"" ._PREFIX_INDEX. "\" >";
	echo "\n<option value=\"none\">" . $_FNMESSAGE['hidden'] . "</option>";
	for ( $i = 0; $i < 100; $i++ )
	{
		$p = $i;
		if ( $p < 10 )
		{
			$p = "0$p";
		}
		$c = "";
		
		if ( !empty($_POST['prefix']) && $_POST['prefix'] == $p )
		{
			$c = "selected=\"selected\"";
		}
		else
		{
			if ($p=="01")
			{
				$c = "selected=\"selected\"";
			}
		}
		echo "\n<option $c value=\"$p\">$i</option>";
	}
	echo "</select>";
	echo "</td></tr>";
	foreach ( $ll as $l )
	{
		echo "\n<tr>";
		echo "<td>" . _TITLE . "($l):</td>";
		echo "<td>";
		echo "<input type=\"text\" name=\"title_$l\" value=\"\" />&nbsp;<img alt=\"$l\" border=\"0\" src=\"" . fromtheme("images/flags/$l.png") . "\" />";
		echo "</td>";
	}
	$js = "if(document.getElementById('optsel').selectedIndex==2){document.getElementById('optselmenu').style.display='inline'}else{document.getElementById('optselmenu').style.display='none'}";
	echo "\n<tr><td>" . $_FNMESSAGE['CC_TYPE'] . ":</td><td> <select id=\"optsel\" onchange=\"$js\" type=\"text\"  name=\"ext\"  >";
	echo "<option value=\"html\" selected=\"selected\" >html</option>";
	echo "<option value=\"php\" >php</option>";
	echo "<option value=\"menu\" >menu</option>";
	echo "</select><div id=\"optselmenu\" style=\"display:none\">";
	//------------sezioni----------------------->
	echo "Path:<select name=\"path\">";
	echo "<option  value=\"\" /></option>";
	$sections = list_sections_translated("sections", true, true);
	foreach ( $sections as $section )
	{
		$s = "";
		if ( !preg_match('/^' . $_FN['vmod'] . '/', $section['link']) && !preg_match('/^none_Control_Center/', $section['link']) )
		{
			$spaces = "";
			$nspaces = explode('/', $section['link']);
			for ( $x = 0; $x < count($nspaces); $x++ )
			{
				$spaces .= "&nbsp;&nbsp;";
			}
			if ( can_modify($_FN['user'], "sections/{$section['link']}") )
			{
				echo "<option $s value=\"" . $section['link'] . "\" />$spaces" . get_section_title($section['link']) . "</option>";
			}
		}
	}
	echo "</select>Separator<select name=\"sep\">
	<option value=\"<br />\" >br</option>
	<option value=\"&amp;nbsp;|&amp;nbsp;\" >&nbsp;|&nbsp;</option>
	<option value=\"&amp;nbsp;&amp;bull;&amp;nbsp;\" >&nbsp;&bull;&nbsp;</option>
	</select><input type=\"checkbox\" name=\"menu_recursive\" value=\"1\" />Recursive&nbsp;
	<input type=\"checkbox\" name=\"menu_recursive_onlyselected\" value=\"1\" />Recursive only current section&nbsp;
	<input type=\"checkbox\" name=\"show_icons\" value=\"1\" />Show icons&nbsp;";
	//------------sezioni-----------------------<
	echo "</div></td></tr>
	";
	echo "</table>
<script type=\"text/javascript\">
$js
</script>
";
	//($path, $menu_recursive, $show_icons, $menu_recursive_onlyselected)
	echo "</div>";
	echo "<input type=\"submit\" class=\"submit\" name=\"title_\" value=\"" . _CREA . "\" />";
	echo "</fieldset>";
	echo "</form>";
	//------------creazione blocco-----------------<
	//------------titolo e posizione blocco----------------->
	echo "<fieldset>";
	echo "<legend>" . $_FNMESSAGE['CC_MODBLOCK'] . "</legend>";
	$sx = displayblocks('sx');
	$op = getparam("opt", PAR_GET, SAN_FLAT);
	echo "<form  method=\"post\" action=\"?mod={$_FN['mod']}&amp;opt=$op\" >";
	$posspan = 1;
	$dirs = glob("blocks/*");
	foreach ($dirs as $dir)
	{
		if (is_dir($dir))
			$posspan++;
	}
	echo "<table>";
	echo "<tr><td colspan=\"2\">File:</td><td style=\"text-align:center\" colspan=\"$posspan\" >" . fn_i18n("_POS") . ":</td>";
	foreach ( $ll as $l )
	{
		echo "<td style=\"text-align:center\" >";
		echo "<img alt=\"\" border=\"0\" src=\"" . fromtheme("images/flags/$l.png") . "\" />";
		echo "</td>";
	}
	echo "</tr>";
	$i = 0;
	foreach ( $dxsx as $blwhere1 )
	{
		$sx = displayblocks($blwhere1);
		//dprint_r($sx);
		foreach ( $sx as $block )
		{
			echo "<tr>";
			//echo "\n<div style=\"display:table-row\">" ;
			echo "\n<td style=\"display:table-cell;\">";
			echo "<a ";
			echo "title=\"" . fn_i18n("_MODIFICA") . "\"";
			echo " href=\"?mod={$_FN['mod']}&amp;opt=$op&amp;editblock=$blwhere1/" . $block['link'] . "\"><img style=\"border:0px;vertical-align:middle\" alt=\"\" src=\"images/modify.png\" /></a></td>";
			echo "<td>" . $block['link'] . ":";
			echo "</td>";
			//echo "<select name=\"{$i}_where\" ";
			//echo "title=\"" . fn_i18n("_POS") . "\"";
			//echo ">";
			foreach ( $dxsx as $blwhere )
			{
				echo "\n<td style=\"display:table-cell;text-align:center\"><div style=\"border:1px inset #d0d0d0;\">";
				if ( $blwhere1 == $blwhere )
					$s = "checked=\"checked\"";
				else
					$s = "";
				$icon = get_icon_blocks($blwhere);
				echo "<input style=\"vertical-align:middle\" type=\"radio\" name=\"{$i}_where\" $s value=\"" . $blwhere . "\" />$icon";
				echo "</div></td>";
			}
			echo "\n<td style=\"display:table-cell\">";
			echo "<select name=\"{$i}_pos\" ";
			echo "title=\"" . fn_i18n("_POS") . "\" >";
			print_all_prefix2("blocks/$blwhere", $block['pos']);
			echo "</select>";
			/* echo "<input ";
			  echo "size=\"3\" type=\"text\" name=\"pos\" value=\"".$block['pos']."\"/> "; */
			echo "</td>";
			foreach ( $ll as $l )
			{
				echo "\n<td style=\"display:table-cell\">";
				echo "<input ";
				echo "title =\"" . fn_i18n("_TITLE") . "($l)\"";
				echo "size=\"8\" type=\"text\" name=\"{$i}_title_$l\" value=\"" . $block['title_' . $l] . "\"/> ";
				echo "</td>";
				//echo "\n<td style=\"display:table-cell\">";
				//echo "<img alt=\"\" border=\"0\" src=\"" . fromtheme("images/flags/$l.png") . "\" />";
				//echo "</td>";
			}
			echo "\n<td style=\"text-align:center\">";
			echo "<input type=\"hidden\"  name=\"{$i}_modify\" value=\"" . $block['link'] . "\"/> ";
			echo "<input type=\"hidden\"  name=\"{$i}_oldwhere\" value=\"" . $block['where'] . "\"/> ";
			//echo "<input type=\"submit\" class=\"submit\" name=\"sub\" value=\"" . _SAVE . "\"/> ";
			echo "</td>";
			//echo "\n<td style=\"text-align:center\">";
			//echo "<input type=\"button\" class=\"button\" name=\"{$i}_mod\" value=\"" . fn_i18n("_MODIFICA") . "\" onclick=\"window.location='?mod={$_FN['mod']}&opt=$op&editblock=$blwhere1/" . $block['link'] . "'\" />";
			//echo "</td>";
			echo "\n<td style=\"text-align:center\">";
			echo "<input type=\"button\" class=\"button\" name=\"{$i}_del\" value=\"" . fn_i18n("_ELIMINA") . "\" onclick=\"check('?mod={$_FN['mod']}&amp;opt=$op&amp;where=" . $block['where'] . "&delblock=" . $block['link'] . "')\" />";
			echo "</td>";
			echo "</tr>";
			$i++;
		}
	}
	echo "</table>";
	echo "<input type=\"submit\" class=\"submit\" name=\"sub\" value=\"" . _SAVE . "\"/> ";
	echo "</form>";
	//------------titolo e posizione blocco-----------------<
}
function get_icon_blocks($where)
{
	global $_FN;
	$icon = "";
	//dprint_r("themes/{$_FN['theme_default']}/images/blocks_{$where}.png");
	if ( file_exists("themes/{$_FN['theme_default']}/images/blocks_{$where}.png") )
	{
		$icon = "themes/{$_FN['theme_default']}/images/blocks_{$where}.png";
	}
	elseif ( file_exists("images/blocks_{$where}.png") )
	{
		$icon = "images/blocks_{$where}.png";
	}

	if ( file_exists($icon) )
	{
		$icon = "<img style=\"vertical-align:middle\" alt=\"$where\" title=\"$where\"  src=\"$icon\" />";
	}
	else
	{
		$icon = "$where";
	}
	return $icon;
}
/**
 * 
 * @param string $edge
 */
function displayblocks($edge)
{
	$handle = opendir('blocks/' . $edge);
	$modlist = array();
	while ( false !== ($file = readdir($handle)) )
	{
		if ( !is_dir("blocks/$edge/$file") and !preg_match("/^\\./s", $file) and !stristr($file, ".xml") and !preg_match('/~$/s', $file) )
		{
			array_push($modlist, $file);
		}
	}
	closedir($handle);
	fn_natsort($modlist);
	$blocks = array();
	global $languages;
	$ll = explode(",", $languages);
	foreach ( $modlist as $mod )
	{
		$retblock['link'] = $mod;
		$retblock['where'] = $edge;
		$tmp = preg_replace("/^[0-9]+_|^none_/si", "", $mod);
		$retblock['pos'] = str_replace("_$tmp", "", $mod);
		$title = str_replace("_", "&nbsp;", str_replace("." . get_file_extension($tmp), "", $tmp));
		$filelang = 'blocks/' . $edge . "/" . preg_replace("/^[0-9]+_|^none_/si", "", $mod) . ".xml";
		if ( file_exists($filelang) )
		{
			$title = getLang($filelang, $title);
		}
		$retblock['title'] = $title;
		foreach ( $ll as $l )
		{
			$title = getLang($filelang, "", $l);
			$retblock['title_' . $l] = $title;
		}
		$blocks[] = $retblock;
	}
	return $blocks;
}
/**
 * 
 * @param string $where
 * @param string $selected
 */
function print_all_prefix2($where, $selected)
{
	global $_FNMESSAGE;
	$ret = array();
	if ( file_exists($where) && is_dir($where) )
	{
		$handle = opendir($where);
		while ( false !== $file = readdir($handle) )
		{
			if ( preg_match("/^[0-9]+_|^none_/si", $file) )
			{
				$tmp = preg_replace("/^[0-9]+_|^none_/si", "", $file);
				$prefix = str_replace("_$tmp", "", $file);
				if ( $prefix != "none" )
					$ret[] = $prefix;
			}
		}
	}
	echo "\n<option value=\"none\">" . $_FNMESSAGE['hidden'] . "</option>";
	for ( $i = 0; $i < 100; $i++ )
	{
		$p = $i;
		if ( $p < 10 )
		{
			$p = "0$p";
		}
		if ( $selected == $p )
			echo "\n<option selected=\"selected\" value=\"$p\">$i</option>";
		else
		{
			if ( !in_array($p, $ret) )
			{
				echo "\n<option value=\"$p\">$i</option>";
			}
			else
			{
				echo "\n<option disabled=\"disabled\" value=\"$p\">$i</option>";
			}
		}
	}
}
?>
