<?php
/**
 * 08_Edit_theme.php created on 17/ott/2008
 *
 * 
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 */
if (!file_exists("./index.php") || !file_exists("./sections"))
	die();
 
global $_FN,$_FNMESSAGE;
$op = getparam("opt", PAR_GET, SAN_FLAT);
$themetoedit = getparam("themetoedit", PAR_GET, SAN_FLAT);
$edit = getparam("edit", PAR_GET, SAN_FLAT);
$editoptions = getparam("editoptions", PAR_GET, SAN_FLAT);
$filecss = getparam("filecss", PAR_GET, SAN_FLAT);

if ($themetoedit == "")
{
	$themetoedit = $_FN['theme_default'];
}
$list_themes = get_list_themes();
?>
<div>
	<form method="get" action="" name="feditth">
		<?php echo _THEME ?> : <select name="theme" onchange=<?php echo "\"window.location='?mod=".$_FN['mod']."&themetoedit='+ document.feditth.theme.options[document.feditth.theme.selectedIndex].text + '&amp;opt=$op'\""?>>
		<?php


foreach ($list_themes as $theme_)
{
	echo "\n<option ";
	if ($themetoedit == $theme_)
	{
		echo ' selected="selected" ';
	}
	echo ">$theme_</option>";
}
?>
		</select>
	</form>
</div>
<?php


if ($edit != "")
	edit_content("$edit", "{$_FN['self']}?mod=" . $_FN['mod'] . "&opt=$op");
else
	if ($editoptions != "")
		fn_editconffile("$editoptions", "{$_FN['self']}?mod={$_FN['mod']}&opt=$op");
	else
	{
		if ($filecss != "" && file_exists("themes/$themetoedit/$filecss"))
		{
			edit_content("themes/$themetoedit/$filecss");
		}
		else
		{
			// verifico se vengono visualizzati i blocchi  --->
			if (file_exists("themes/$themetoedit/index.tp.html"))
			{
				if (false === strpos(file_get_contents("themes/$themetoedit/index.tp.html"),"{fnblock"))
				{
					echo "<br /><img src=\"".fromtheme("images/icons/warning.png")."\" />";
					echo "&nbsp;&nbsp;<b>".$_FNMESSAGE['themenoblock']."</b>";
				}
			}
			else
				if (false === strpos(file_get_contents("themes/$themetoedit/structure.php"),"create_blocks"))
				{
					echo "<br /><img src=\"".fromtheme("images/icons/warning.png")."\" />";
					echo "&nbsp;&nbsp;<b>".$_FNMESSAGE['themenoblock']."</b>";
				}
			// verifico se vengono visualizzati i blocchi  ---<
			
			$listfiles = glob("themes/$themetoedit/*.css");

			echo "<br /><br />";

			echo "&nbsp;<img border=\"\" alt=\"\" style=\"vertical-align:middle\"src=\"" . fromtheme("images/modify.png") . "\" />&nbsp;";

			echo "<a href=\"?mod=" . $_FN['mod'] . "&amp;opt=$op&amp;themetoedit=$themetoedit&amp;edit=themes/$themetoedit/structure.php\">" . $_FNMESSAGE['editstructuretheme'] . " \"$themetoedit\" (structure.php)</a>";

			//----variabili all'interno di theme.php ---->
			$fg=file("themes/$themetoedit/theme.php");
			// scansione file alla ricerca delle variabili
			for ( $i=0;$i < count($fg);$i++ )
			{
				if ( preg_match('/^\$./s',$fg[$i]) ) // prende solo le righe che iniziano col carattere "$"
				{
					$line_tmp1=explode("=",$fg[$i]);
					if (isset($line_tmp1[1]))
					{
						echo "<br />";
						echo "&nbsp;<img border=\"\" alt=\"\" style=\"vertical-align:middle\"src=\"" . fromtheme("images/configure.png") . "\" />&nbsp;";
						echo "<a href=\"?mod=" . $_FN['mod'] . "&amp;opt=$op&amp;themetoedit=$themetoedit&amp;editoptions=themes/$themetoedit/theme.php\">" . $_FNMESSAGE['configuretheme'] . "</a>";
						break;
					}
				}
			}

			if (file_exists("themes/$themetoedit/config.php"))
			{
				echo "<br />";
				echo "&nbsp;<img border=\"\" alt=\"\" style=\"vertical-align:middle\"src=\"" . fromtheme("images/modify.png") . "\" />&nbsp;";
				echo "<a href=\"?mod=" . $_FN['mod'] . "&amp;opt=$op&amp;themetoedit=$themetoedit&amp;editoptions=themes/$themetoedit/config.php\">" . $_FNMESSAGE['configuretheme'] . " (config.php)</a>";
			}

			if (count($listfiles) > 0)
			{
				echo "<br /><br /><table>";
				echo "<tr><td><b>CSS :</b></td><td>&nbsp;</td></tr>";
				foreach ($listfiles as $file)
				{
					$file2 = basename($file);
					$urlcss = $_FN['siteurl'] . "/themes/$themetoedit/$file2";
					echo "<tr><td>$file</td><td><a href=\"?mod=" . $_FN['mod'] . "&amp;opt=$op&amp;filecss=$file2&amp;themetoedit=$themetoedit\">[" . _MODIFICA . "]</a></td><td><a href=\"http://jigsaw.w3.org/css-validator/validator?uri=$urlcss&amp;profile=css21&amp;usermedium=all\" onclick=\"window.open(this.href);return false;\"><img style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/validate/valid_css.png") . "\" alt=\"validate\" /></a></td></tr>";
				}
				echo "</table>";
			}
			echo "<br /><br /><img border=\"\" alt=\"\" style=\"vertical-align:middle\"src=\"" . fromtheme("images/modify.png") . "\" />&nbsp;";
			echo "<a href=\"?mod=none_Control_Center&opt=00_options/01_generale\">" . $_FNMESSAGE['modifythemedefault'] . " (" . $_FN['theme_default'] . ")</a><br />";
			
			if (false && file_exists("themes/$themetoedit/templates/"))
			{

				$listfiles = glob("themes/$themetoedit/templates/*.html");
				if (count($listfiles) > 0)
				{
					echo "<h2>Templates</h2><table>";
					foreach ($listfiles as $file)
					{
						$file2 = basename($file);
						$filetoedit = "themes/$themetoedit/templates/$file2";
						echo "<tr><td>$file</td><td><a href=\"?mod=" . $_FN['mod'] . "&amp;opt=$op&amp;themetoedit=$themetoedit&amp;edit=$filetoedit\">[" . _MODIFICA . "]</a></td></tr>";
					}
					echo "</table>";
				}

			}
		}
		echo "<br />";
		echo "<br />";
		echo _ANTEPRIMA."<br />$themetoedit";
		echo "<iframe style=\"border:1px solid inset;height:280px;width:100%\" src=\"index.php?mod={$_FN['home_section']}&amp;testtheme=$themetoedit\"></iframe>";

	}

function get_list_themes()
{
	$handle = opendir("themes/");
	$list_themes = array ();
	while (false !== ($file = readdir($handle)))
	{
		if (!($file == "." or $file == "..") and is_dir("themes/$file"))
		{
			if (file_exists("themes/$file/theme.php"))
				array_push($list_themes, $file);
		}
	}
	closedir($handle);
	return $list_themes;
}
?>