<?php
if (!file_exists("./index.php") || !file_exists("./sections"))
	die();

/**
 * 10_create_theme.php 
 *
 * 
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 */
global $_FN,$_FNMESSAGE;
$op = getparam("opt", PAR_GET, SAN_FLAT);
$themename = getparam("themename", PAR_POST, SAN_FLAT);
$fromtheme = getparam("fromtheme", PAR_POST, SAN_FLAT);
$themename=str_replace(" ","_",trim(ltrim($themename)));
if (!is_admin())
	die(_NONPUOI);
if (!is_writable("themes"))
{
	echo "<b>"._ERROR_PERM."</b><br /><br />";
	echo _ERROR_PERM_FIX1."";
	echo "<pre>themes</pre>";

}
else
if ($themename != "")
{
	$themename=str_replace(" ","_",$themename);
	if (file_exists("themes/$themename"))
	{
		echo $_FNMESSAGE['themeexists'];
	}
	else
	{
		mkdir("themes/$themename");
		fn_copy_dir("themes/$fromtheme", "themes/$themename",0757,false);
		echo $_FNMESSAGE['createthemeok'];
	}

}
else
{
	echo "<form action=\"?mod=" . $_FN['mod'] . "&amp;opt=$op\" method=\"post\">";

	echo $_FNMESSAGE['themename'] . ":<br /><input size=\"15\" name=\"themename\" /><br />";
	$list_themes = get_list_themes();
	echo "<br />".$_FNMESSAGE['fromtheme'] . ":<br /><select name=\"fromtheme\">";
	foreach ($list_themes as $theme_)
	{
		echo "\n<option value=\"$theme_\">$theme_</option>";
	}
	echo "</select><br /><br />";


	echo "<input type=\"submit\" value=\"" . $_FNMESSAGE['createtheme'] . "\"/>";
	echo "</form>";
}
function get_list_themes()
{
	$handle = opendir("themes/");
	$list_themes = array ();
	while (false !== ($file = readdir($handle)))
	{
		if (!($file == "." or $file == "..") and is_dir("themes/$file"))
		{
			if (file_exists("themes/$file/theme.php"))
				array_push($list_themes, $file);
		}
	}
	closedir($handle);
	return $list_themes;
}
?>