<?php
/**
 * section.php
 * 
 * Created on 12-feb-2007
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * 
 * @copyright Copyright (c) 2007
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 * 
 */
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}
global $_FNMESSAGE,$_FN;
require_once ("sections/{$_FN['vmod']}/cc_functions.php");
if (  !is_admin() )
{
	$op = getparam("opt",PAR_GET,SAN_FLAT);
	global $remember_login;
	OpenTableTitle(_LOGIN);
	echo "
<form
	style=\"margin:auto;width:300px;\"
	action=\"?mod={$_FN['mod']}&amp;fnlogin=login&amp;opt=$op\"
	method=\"post\"><input type=\"hidden\" name=\"op\" value=\"login\" /> <input
	type=\"hidden\" name=\"from\" value=\"{$_FN['mod']}\" /> <label for=\"username\">".
	fn_i18n("_NOMEUTENTE").":<br />
</label> <input alt=\"username\" name=\"username\" size=\"20\" id=\"username\" /><br />
<label for=\"password\">".
	fn_i18n("_PASSWORD")."</label>:<br />
<input alt=\"password\" name=\"password\" type=\"password\" size=\"20\" /><br />";
if ( $remember_login == 1 )
	{
		echo "\n<div style=\"margin:1em;\"><label for=\"rememberlogin\">" . fn_i18n("_REMEMBERLOGIN") . "</label>";
		echo "\n<input type=\"checkbox\" alt=\"remember_login\" name=\"rememberlogin\" id=\"rememberlogin\" /><br />";
		echo "\n</div>";
	}
	else
		echo "<br />";
	echo "<button type=\"submit\" class=\"submit\" >".fn_i18n("_LOGIN")." </button></form>";
	CloseTableTitle();
	return;
}
else
{
	$op = getparam("opt",PAR_GET,SAN_FLAT);
	if ( false && $op == "" )
	{
		echo "\n<h1>" . $_FNMESSAGE['_FCC_MAINTITOLO'] . "</h1>";
		ShowAdminMenuBig();
	}
	else
	{
		echo "\n<table cellspacing=\"0\" cellpadding=\"3\" width=\"100%\">";
		echo "\n\t<tr>";
		if ( $_FN['theme'] != "mobile" )
		{
			echo "\n\t\t<td valign=\"top\" width=\"180\">";
			ShowAdminMenu();
		}
		echo "</td>\n\t";
		echo "<td valign=\"top\" >";
		if ( $op == "" )
		{
			OpenTableTitle($_FNMESSAGE['_FCC_MAINTITOLO']);
			ShowAdminMenuBig();
			CloseTableTitle();
		}
		else
		{
			Show_h_menu_admin($op);
			if ( preg_match('/^sections_/s',$op) || $op == "general_config" )
			{
				$op = getparam("opt",PAR_GET,SAN_FLAT);
				$p = preg_replace('/^sections_/s','',$op);
				if ( file_exists("sections/$p/config.php") )
				{
					$t = get_section_title("$p",$_FN['lang']);
					echo "<h2>" . _SECTIONADMINOPTIONS . " \"$t\" :" . "</h2>";
					fn_editconffile("sections/$p/config.php","{$_FN['self']}?mod={$_FN['mod']}");
				}
				if ( $op == "general_config" )
					fn_editconffile("config.php","{$_FN['self']}?mod={$_FN['mod']}");
				if ( file_exists("sections/$p/controlcenter_module.php") )
					include ("sections/$p/controlcenter_module.php");
			}
			else 
				if ( file_exists("sections/{$_FN['vmod']}/none_modules/$op.php") )
					include ("sections/{$_FN['vmod']}/none_modules/$op.php");
		
		}
	}
	echo "</td>\n\t</tr>\n</table>";
}
/**
 * 
 * @param bool $big
 */
function get_modules($big = true)
{
	global $_FN,$_FNMESSAGE;
	$sections = list_subsections("sections/{$_FN['vmod']}/none_modules",true);
	$ret = array();
	$st = "border:0px;vertical-align:middle";
	if ( $big == false )
		$st = "border:0px;height:24px;vertical-align:middle";
	foreach ( $sections as $sec )
	{
		$title = $sec;
		$tmp = preg_replace("/^[0-9][0-9]+_/si","",$sec);
		$title = str_replace("_","&nbsp;",str_replace(".php","",$tmp));
		$filelang = 'sections/' . "{$_FN['vmod']}/none_modules/$sec" . "/lang.xml";
		if ( file_exists($filelang) )
		{
			$title = getLang($filelang,$title);
		}
		if ( file_exists('sections/' . "{$_FN['vmod']}/none_modules/$sec/icon.png") )
		{
			if ( $big == false )
				$ret[$sec]['icon'] = "sections/{$_FN['vmod']}/none_modules/$sec/icon.png";
			else
				$ret[$sec]['icon'] = "<img style=\"border:0px\" alt=\"\" src=\"" . 'sections/' . "{$_FN['vmod']}/none_modules/$sec/icon.png" . "\" />";
		}
		else
		{
			if ( $big == false )
				$ret[$sec]['icon'] = fromtheme("images/section.png");
			else
				$ret[$sec]['icon'] = "<img style=\"border:0px\" alt=\"\" src=\"" . fromtheme("images/section.png") . "\" />";
		}
		$ret[$sec]['title'] = $title;
		$modules = FN_LoadFilelist("sections/{$_FN['vmod']}/none_modules/$sec");
		$tmpret = array();
		foreach ( $modules as $mod )
		{
			$title = $mod;
			$idret = basename($mod);
			if ( $idret == "section.php" )
				continue;
			$tmpret[$idret]['include'] = $mod;
			$tmp = preg_replace("/^[0-9]+_/si","",$idret);
			$title = str_replace("_","&nbsp;",str_replace(".php","",$tmp));
			$filelang = 'sections/' . "{$_FN['vmod']}/none_modules/$sec" . "/" . preg_replace("/^[0-9]+_/si","",$idret) . ".xml";
			$fileicon = 'sections/' . "{$_FN['vmod']}/none_modules/$sec" . "/" . preg_replace("/^[0-9]+_/si","",preg_replace('/.php$/si','',$idret)) . ".png";
			if (  !file_exists($fileicon) )
				$fileicon = "sections/{$_FN['vmod']}/controlcenter.png";
			$tmpret[$idret]['icon'] = "<img style=\"$st\" src=\"$fileicon\" alt=\"\"  />";
			if ( file_exists($filelang) )
			{
				$title = getLang($filelang,$title);
			}
			$tmpret[$idret]['title'] = $title;
			$opt = preg_replace('/.php$/si','',$idret);
			$tmpret[$idret]['op'] = "$sec/$opt";
			$tmpret[$idret]['link'] = "?mod={$_FN['vmod']}&amp;opt=$sec/$opt";
		}
		$ret[$sec]['modules'] = $tmpret;
	}
	//sezioni------>
	$sectionmodules = array();
	$mods = list_subsections("sections",true,true);
	$show = false;
	foreach ( $mods as $mod )
	{
		if ( file_exists("sections/$mod/controlcenter_module.php") || file_exists("sections/$mod/config.php") )
		{
			$tit = "";
			$albero = explode("/",$mod);
			$so = sizeof($albero);
			for ( $i = 0;$i < $so;$i++  )
			{
				$mypath = "";
				for ( $j = 0;$j <= $i;$j++  )
				{
					$mypath .= $albero[$j];
					if ( $i > 0 and ($j != $i) )
						$mypath .= "/";
				}
				$tmp = getLang("sections/$mypath/lang.xml",preg_replace("/^[0-9][0-9]_/si","",$albero[$i]));
				$tit .= str_replace("_","&nbsp;",$tmp);
				if ( $i != $so - 1 )
					$tit .= "/";
			}
			$sectionmodules[$mod]['op'] = "sections_$mypath";
			$sectionmodules[$mod]['link'] = "?mod={$_FN['mod']}&amp;opt=sections_$mypath";
			$sectionmodules[$mod]['title'] = "$tit";
			$sectionmodules[$mod]['include'] = "sections/$mod/controlcenter_module.php";
			$fileicon = "sections/{$_FN['vmod']}/controlcenter.png";
			$sectionmodules[$mod]['icon'] = "<img style=\"$st\" alt=\"\" src=\"$fileicon\" />";
			if ( $big == true && file_exists("sections/$mod/icon.png") )
				$sectionmodules[$mod]['icon'] .= "<img style=\"position:absolute;top:30px;right:10px;border:0px;\" alt=\"\" src=\"sections/$mod/icon.png\" />";
		}
	}
	if ( count($sectionmodules) > 0 )
	{
		if ( $big == true )
			$ret['section']['icon'] = "<img style=\"border:0px\" alt=\"\" src=\"" . fromtheme("images/section.png") . "\" />";
		else
			$ret['section']['icon'] = fromtheme("images/section.png");
		$ret['section']['title'] = $_FNMESSAGE['sectionoption'];
		$ret['section']['modules'] = $sectionmodules;
	}
	//sezioni------<
	return $ret;
}
/**
 * show menu
 */
function ShowAdminMenu()
{
	$modules = get_modules(false);
	//dprint_r($modules);
	$op = getparam("opt",PAR_GET,SAN_FLAT);
	foreach ( $modules as $module )
	{
		OpenBlock($module['icon']," " . $module['title']);
		foreach ( $module['modules'] as $submodule )
		{
			//$icon = "<img src=\"".fromtheme("images/subsection.png")."\" alt=\"\"/>";
			$icon = $submodule['icon'];
			if ( $op == $submodule['op'] )
				echo "<b>	";
			echo "$icon&nbsp;<a style=\"\" href=\"{$submodule['link']}\" >{$submodule['title']}</a>";
			if ( $op == $submodule['op'] )
				echo "</b>";
			echo "<br />";
		}
		CloseBlock();
		echo "<br />";
	}
}
/**
 * print cc menu
 * @param string $op
 */
function Show_h_menu_admin($op)
{
	global $_FN;
	$sec = dirname($op);
	$modules = FN_LoadFilelist("sections/{$_FN['vmod']}/none_modules/$sec");
	if ( $sec != "." )
	{
		$sep = "";
		echo "<div>";
		foreach ( $modules as $mod )
		{
			$title = $mod;
			$idret = basename($mod);
			if ( $idret == "section.php" )
				continue;
			$tmp = preg_replace("/^[0-9]+_/si","",$idret);
			$title = str_replace("_","&nbsp;",str_replace(".php","",$tmp));
			$filelang = 'sections/' . "{$_FN['vmod']}/none_modules/$sec" . "/" . preg_replace("/^[0-9]+_/si","",$idret) . ".xml";
			$fileicon = 'sections/' . "{$_FN['vmod']}/none_modules/$sec" . "/" . preg_replace("/^[0-9]+_/si","",preg_replace('/.php$/si','',$idret)) . ".png";
			if (  !file_exists($fileicon) )
				$fileicon = "sections/{$_FN['vmod']}/controlcenter.png";
			$image = "<img style=\"height:16px;vertical-align:middle\" src=\"$fileicon\" alt=\"$title\" title=\"$title\" />";
			if ( file_exists($filelang) )
			{
				$title = getLang($filelang,$title);
			}
			$opt = preg_replace('/.php$/si','',$idret);
			$href = "?mod={$_FN['vmod']}&amp;opt=$sec/$opt";
			echo $sep;
			if ( "$sec/$opt" == $op )
				echo "<span  style=\"white-space:nowrap;\">$image&nbsp;<a style=\"white-space:nowrap;\" href=\"$href\"><b>$title</b></a></span>";
			else
				echo "<span  style=\"white-space:nowrap;\">$image&nbsp;<a style=\"white-space:nowrap;;\" href=\"$href\">$title</a></span>";
			$sep = " | ";
		}
		echo "</div><hr />";
	}
}
/**
 * Print menu (big icon)
 */
function ShowAdminMenuBig()
{
	$modules = get_modules(true);
	//dprint_r($modules);
	$op = getparam("opt",PAR_GET,SAN_FLAT);
	foreach ( $modules as $module )
	{
		echo "<br style=\"clear:both\"/>" . $module['icon'] . " " . $module['title'];
		echo "<hr />";
		foreach ( $module['modules'] as $submodule )
		{
			echo "<div title=\"{$submodule['title']}\" style=\"overflow:hidden;position:relative;margin:3px;float:left;display:block;width:90px;height:90px;text-align:center;\" >";
			echo "<a  href=\"{$submodule['link']}\" >{$submodule['icon']}</a>";
			echo "<br /><a href=\"{$submodule['link']}\" >{$submodule['title']}</a>";
			echo "</div>";
		}
	}
}
?>