<?php
/* **********************************************************************/
/* FlatNuke - Flat Text Based Content Management System                 */
/* ============================================                         */
/*                                                                      */
/* Copyright (c) 2003-2004 by Simone Vellei                             */
/* http://flatnux.sf.net                                      */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/* **********************************************************************/
# previene che blocco sia eseguito direttamente e redirige a index.php
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}
global $_FN;
global $module,$find,$listfind,$method;
$find = strippostpslashes (getparam("find",PAR_GET,SAN_FLAT));
if ( $find == "" )
	$find = strippostpslashes ( getparam("find",PAR_POST,SAN_FLAT) );
$module = getparam("where",PAR_GET,SAN_FLAT);
if ( false !== (strpos($module,"..")) )
	$module = $_FN['mod'];
if ( $module == "" )
	$module = getparam("where",PAR_POST,SAN_FLAT);
$method = getparam("method",PAR_GET,SAN_FLAT);
if ( $method == "" )
	$method = getparam("method",PAR_POST,SAN_FLAT);
$find = htmlentities($find);
$method = htmlentities($method);
$module = htmlentities($module);
$module = find_section($module);
//echo $module;
$search_in_hidden_sections = 0;
include ("sections/" . $_FN['vmod'] . "/config.php");
$mods = list_sections("sections",$search_in_hidden_sections,true);
if ( $module != null )
{
	$ms[0] = $module;
}
else
	$ms = $mods;
$allres = array();
if ( $find != null && strlen($find) > 1 )
{
	foreach ( $ms as $module )
	{
		$sectlevel = getsectlevel($module);
		/** filtro le sezioni in cui non ho il permesso **/
		if ( $sectlevel <= getlevel($_FN['user']) )
		{
			if ( $find != "" )
				searchinhtml($module,$allres,$find,$method);
			if ( file_exists("sections/$module/search.php") )
			{
				$listfind = array();
				if ( $method != "" )
				{
					while (strstr("  ",$find))
						$find = str_replace("  "," ");
					$listfind = explode(" ",trim($find));
				}
				else
				{
					$listfind[0] = $find;
				}
				$res = array();
				include ("sections/$module/search.php");
				if ( count($res) > 0 )
				{
					$tmp = str_replace("_","&nbsp;",preg_replace("/^[0-9][0-9]_/s","",$module));
					$tmp = getLang("sections/$module/lang.xml",$tmp,$_FN['lang']);
					$allres[] = "<h3>$tmp</h3>";
					$allres = array_merge($allres,$res);
				}
			}
			//else
			{
			}
		}
	}
	if ( count($allres) == 0 )
	{
		if ( isset($_GET['find']) )
			echo _NORESULT . "<br /><a href=\"javascript:history.back();\">&lt;&lt; " . _INDIETRO . "</a>";
	}
	else
	{
		foreach ( $allres as $r )
		{
			if ( $r != "" )
				echo "<br />$r";
		}
	}
}
else
	echo _FNREQVALIDFIED;
/**
 * Cerca una stringa all' interno di un file html
 * @param &array res
 * @param string module modulo
 * @param string find parola da cercare
 */
function searchinhtml($module, & $res, $find, $method = false)
{
	global $_FN;
	$ll = explode(",",$_FN['languages']);
	if ( $find == "" )
		return;
	if ( $method != "" )
	{
		while (strstr("  ",$find))
			$find = str_replace("  "," ");
		$listfind = explode(" ",trim($find));
	}
	else
		$listfind[0] = $find;
	foreach ( $ll as $l )
	{
		$sectiontitle = get_section_title($module,$l);
		//echo "<br>l= $sectiontitle $module";
		$alltext = $sectiontitle;
		if ( file_exists("sections/$module/section.$l.html") )
		{
			$alltext .= " " . strip_tags(file_get_contents("sections/$module/section.$l.html"));
		}
		$found = false;
		$alltextdecode = html_entity_decode($alltext);
		foreach ( $listfind as $q )
		{
			$q = html_entity_decode($q,ENT_QUOTES,_CHARSET);
			if ( $q != "" )
			{
				if ( stristr($alltext,$q) !== false || stristr($alltextdecode,$q) !== false )
				{
					$found = true;
				}
				else
				{
					if ( $method == "AND" )
					{
						$found = false;
						break;
					}
				}
			}
		}
		if ( $found )
		{
			//-------------se si tratta di una sottosezione --->
			$titoli = "";
			$albero = explode("/",$module);
			$sep = "";
			for ( $i = 0;$i < sizeof($albero);$i++  )
			{
				$mypath = "";
				for ( $j = 0;$j <= $i;$j++  )
				{
					if ( $i > 0 and ($j != $i) )
					{
						$mypath .= $albero[$j] . "/";
					}
					else
					{
						$mypath .= $albero[$j];
					}
				}
				$tmp = str_replace("none_","",$albero[$i]);
				$tmp = preg_replace("/^[0-9][0-9]_/si","",$tmp);
				$tmp = str_replace("_","&nbsp;",$tmp);
				$tmp = getLang("sections/$mypath/lang.xml",$tmp);
				$titoli .= $sep . $tmp;
				$sep = "/";
			}
			$str = "<img src=\"" . fromtheme("images/section.png") . "\" alt=\"section\" />&nbsp;<a href=\"index.php?mod=$module&amp;lang=$l\" >" . $titoli . "</a>";
			if ( count($ll) > 1 )
				$str .= "&nbsp;<img height=\"10\" alt=\"$l\" src=\"" . fromtheme("images/flags/$l.png") . "\" />";
			array_push($res,$str);
		}
	}
}
?>
<div align="center">
<form action="index.php" method="get"><input type="hidden" name="mod"
	value="<?php
	echo $_FN['mod']?>">
<?php
echo _CERCASTR?><br />
<br />
<select name="where">
<?php
foreach ( $mods as $mod )
{
	if ( file_exists("sections/$mod/search.php") )
	{
		$tit = "";
		$albero = explode("/",$mod);
		for ( $i = 0;$i < sizeof($albero);$i++  )
		{
			$mypath = "";
			for ( $j = 0;$j <= $i;$j++  )
			{
				if ( $i > 0 and ($j != $i) )
				{
					$mypath .= $albero[$j] . "/";
				}
				else
				{
					$mypath .= $albero[$j];
				}
			}
			$tmp = str_replace("none_","",$albero[$i]);
			$tmp = preg_replace("/^[0-9][0-9]_/si","",$tmp);
			$tmp = getLang("sections/$mypath/lang.xml",$tmp);
			if ( $i != (sizeof($albero) - 1) )
			{
				$tit .= str_replace("_","&nbsp;",$tmp) . "/";
			}
			else
			{
				$tit .= str_replace("_","&nbsp;",$tmp);
			}
		}
		?>
 <option
		<?php
		if ( isset($_GET['where']) && sectionlocation($_GET['where']) == $mod )
			echo " selected=\"selected\" ";
		?>
		value="<?php
		echo $mod?>"><?php
		echo $tit?></option>
<?php
	}
}
?>

<option value=""
		<?php
		if (  !isset($_GET['where']) || (isset($_GET['where']) && $_GET['where'] == "") )
			echo "selected=\"selected\"";
		?>><?php
		echo _SALLSITE?></option>
</select> <br />
<br />
<input type="text" name="find" size="20" value="<?php
echo $find?>"> <button type="submit" class="submit"><?php
	echo _CERCA?></button><br />
<br />

<input name="method" type="radio"
	<?php
	if ( $method == "AND" )
		echo "checked=\"true\"";
	?>
	value="AND" /><?php
	echo _FF_ALLWORDS?>
<input name="method" type="radio"
	<?php
	if ( $method == "OR" )
		echo "checked=\"true\"";
	?> value="OR" /><?php
	echo _FF_ANYWORDS?>
<input name="method" type="radio"
	<?php
	if ( $method == "" )
		echo "checked=\"true\"";
	?> value="" /><?php
	echo _FRASEESATTA?>

</form>
</div>